== Changelog ==

Some changes only applicable to WS Form PRO.

= 1.12.7 - 08/25/2026 =
* Added: Support for Google Maps JS Routes API (New) - Setting in WS Form > Settings > Advanced for accounts created after March 1st, 2025
* Bug Fix: Admin header overlapping the WordPress admin menu

= 1.12.6 - 08/13/2026 =
* Added: Improved PHP AI Client SDK model caching

= 1.12.5 - 08/12/2026 =
* Added: Column selection and ordering for submission CSV exports

= 1.12.4 - 08/11/2026 =
* Added: Auto Delete Submissions can now permanently delete submissions in addition to moving them to trash https://wsform.com/knowledgebase/auto-delete-submissions/
* Bug Fix: Google Address field styling in dark mode and alt color scheme
* Bug Fix: Request Support button in the Support sidebar

= 1.12.3 - 08/07/2026 =
* Added: Dual-list selector for multi-select settings
* Bug Fix: Blank Debug settings section in LITE

= 1.12.2 - 08/04/2026 =
* Added: AI / MCP Server style list, get, create, update, and delete abilities
* Added: Reduced front-end style CSS by omitting unused shade variables
* Added: Optimized layout CSS
* Added: Breakpoint queries setting to use form width or browser width
* Bug Fix: Statistics confirmation modal

= 1.12.1 - 07/31/2026 =
* Bug Fix: Some add-on settings not showing or saving correctly

= 1.12.0 - 07/29/2026 =
* Added: Improved admin UI across the layout editor, settings, and submissions
* Added: AI / MCP Server update with field update, tab, section, field, action, conditional, and submission note abilities
* Added: Notes system for submissions
* Added: Helper functions for adding and retrieving submission notes
* Added: AbuseIPDB spam protection
* Added: Rollback unpublished form changes to the last published version in the History tab
* Added: Visual Form Builder (free) migration tool (PRO)
* Added: Embed tab in the layout editor
* Added: Redesigned status page with copy and download
* Added: Security hardening
* Added: Submission form selector now shows record counts
* Added: Improved drag and drop import for forms and styles
* Added: Improved license logging
* Changed: Renamed Select field Options tab to Choices
* Removed: IntroJS first-run tutorial
* Bug Fix: Prevented license deactivation on multilingual sites using multiple hostnames. Requires an available license activation for each hostname.
* Bug Fix: Styler font style, letter spacing, text decoration, and text transform not applying to labels
* Bug Fix: Unread submissions bubble not updating after marking as unread
* Bug Fix: Import now rejects the wrong type of JSON file
* Bug Fix: Data source errors now show a single clear message
* Bug Fix: Preset data source when the remote file cannot be retrieved
* Bug Fix: DropzoneJS remove on Android phones

= 1.11.19 - 07/16/2026 =
* Added: List submissions and get submission abilities
* Added: Draft form ability
* Added: AI Connectors status on the AI settings tab
* Added: Setting to include WS Form abilities in MCP discovery
* Added: Improved the AI settings tab
* Changed: Form statistics ability now includes daily figures

= 1.11.18 - 07/15/2026 =
* Bug Fix: Restored wsf-hidden and wsf-hidden-element classes in framework CSS
* Bug Fix: Fields created from action templates now use the default label when no label is specified

= 1.11.17 - 07/12/2026 =
* Added: WPBakery extension
* Changed: Layout and style CSS now use a single file for LTR and RTL sites, removing the need for separate RTL CSS files

= 1.11.16 - 07/09/2026 =
* Added: Improved accessibility of section legends, checkbox/radio option groups, the top admin menu, and debug console
* Added: Improved ARIA labels generated from labels containing HTML
* Added: Styler back button
* Changed: Checkbox and radio group labels now use non-label elements for improved accessibility compliance

= 1.11.15 - 06/30/2026 =
* Bug Fix: Resolved a language reference console warning that could occur when rendering forms

= 1.11.14 - 06/29/2026 =
* Added: wsf_cookie_expiry filter hook for overriding the expiry (in seconds) of cookies set by WS Form
* Added: Support for j F, Y European date format (e.g. 8 June, 2018) in the date/time picker
* Changed: Added a WS_FORM_INTRO constant to enable or disable the first-run layout editor tutorial (intro.js hints), which is now disabled by default
* Changed: Redesigned the welcome screen shown after installation into a single streamlined page with an introduction video and direct links to create your first form or view documentation
* Bug Fix: Forms list table columns now size to their content, so long shortcodes no longer overflow the Shortcode column and column heading sort indicators no longer wrap to a second line
* Bug Fix: Layout editor would not allow a field or section to be dropped into a section that had to be scrolled into view during the drag, because cached drop target positions were not refreshed while auto-scrolling
* Bug Fix: Selected text in select fields became invisible when focused via keyboard in modern Firefox, caused by an obsolete :-moz-focusring transparency hack that newer Firefox versions no longer compensate for

= 1.11.13 - 06/22/2026 =
* Added: Protection against a fatal error caused by a misconfigured WordPress installation, where WordPress is set to use the FTP/SSH filesystem method but no credentials have been provided
* Bug Fix: Plugin updater is now registered on the 'init' hook instead of 'admin_init' so available updates are detected during WP-Cron and REST/background requests, not just on admin page loads

= 1.11.12 - 06/19/2026 =
* Bug Fix: CodeMirror field edits now trigger input and change events so conditional logic and validation update correctly
* Bug Fix: Select2 cascading fields now clear cached option data when options are rebuilt, fixing selection issues with multiple selects

= 1.11.11 - 06/18/2026 =
* Added: Workaround for a third party plugin bug that could cause a fatal error on the WordPress plugin update screens
* Bug Fix: Honeypot spam protection field now uses the correct tabindex attribute
* Bug Fix: Cloudflare Turnstile using the Interaction Only appearance mode was hidden by CSS, preventing visitors from completing the interactive challenge (field spacing now also collapses when no challenge is shown)

= 1.11.10 - 06/17/2026 =
* Added: New JavaScript hook for resolving custom parse variables client-side
* Bug Fix: Phone field International Telephone Input (ITI) country dropdown now uses the WS Form color system instead of hardcoded colors

= 1.11.9 - 06/12/2026 =
* Added: AI action temperature is now optional and accepts a value from 0.0 to 2.0 (some models do not support temperature)
* Bug Fix: AI action now handles errors returned by the WordPress AI Client

= 1.11.8 - 06/08/2026 =
* Added: Hardened capability checks on settings updates

= 1.11.7 - 06/01/2026 =
* Bug Fix: Inside label on Price field type

= 1.11.6 - 05/26/2026 =
* Added: Redirect action URL now translatable

= 1.11.5 - 05/21/2026 =
* Bug Fix: Data grid row IDs

= 1.11.4 - 05/20/2026 =
* Added: WordPress 7 readiness
* Added: Input mask library version updated
* Bug Fix: Expired submission date_expire fix
* Bug Fix: Places API (New) type fix

= 1.11.3 - 05/15/2026 =
* Added: Updated for new WordPress 7 wp_ai_client_prompt method

= 1.11.2 - 05/14/2026 =
* Added: Upgraded input mask library to version 5.0.9
* Added: Default value, prefix and suffix added to translatable strings

= 1.11.1 - 05/12/2026 =
* Added: Conditional logic "Variable" IF condition that allows you to test any string containing WS Form variables
* Added: Data grid now supports pasting of multiple rows or a CSV file into it https://wsform.com/knowledgebase/pasting-content-into-data-grids/
* Added: Data grid CSV import/export now includes a wsf_group column for groups https://wsform.com/knowledgebase/data-grid-csv-import-and-export/
* Added: New #blog_locale, #blog_locale_language_code, and #blog_locale_country_code variables
* Added: New #client_language, #client_locale, #client_locale_language_code, and #client_locale_country_code variables
* Added: New #user_language, #user_locale, #user_locale_language_code, and #user_locale_country_code variables
* Added: Multiple setting on conditional logic string comparisons

= 1.11.0 - 05/08/2026 =
* Added: Per-form translation with automatically updated translatable strings https://wsform.com/knowledgebase/translate-forms/
* Added: WPML integration
* Added: Polylang integration
* Added: Weglot integration
* Changed: Auto publish no longer occurs if form changed to draft status
* Bug Fix: Layout CSS for RTL

= 1.10.89 - 04/26/2026 =
* Added: Silent exit if add view fails to avoid unnecessary error logs (e.g. invalid form ID)
* Added: Object filtering on submission view and export

= 1.10.88 - 04/23/2026 =
* Changed: Report wp_schedule_event args no longer uses key value pairs
* Bug Fix: wsf_submit_set_value and wsf_submit_set_value_by_field_id functions
* Bug Fix: Custom HTML for move up and move down buttons in repeatable section icons
* Bug Fix: Minimum Date and Maximum Date setting on date field timezone issue

= 1.10.87 - 04/10/2026 =
* Bug Fix: Substring fix for WS Form variable parameters

= 1.10.86 - 04/09/2026 =
* Added: Support for Google Drive shared folders and drives for Media Capture field

= 1.10.85 - 04/06/2026 =
* Bug Fix: ACF taxonomy field value handling for different sub field types
* Bug Fix: Form checksum calculation during styler rendering

= 1.10.84 - 04/04/2026 =
* Bug Fix: Improved dependency checks for add-on enqueued scripts and styles

= 1.10.83 - 04/02/2026 =
* Added: Fix to license checks when hostname reported incorrectly due to WPML manipulating home_url()
* Added: Updated translations
* Bug Fix: count_* form fields now excluded from form checksum calculation
* Bug Fix: Improved checks for already enqueued scripts and styles

= 1.10.82 - 03/23/2026 =
* Added: License activity logging https://wsform.com/knowledgebase/license-activity-logging/
* Added: Support for French typographic time format (G \h i)
* Bug Fix: #checkbox_count
* Bug Fix: Serialized object instantiation filtering
* Bug Fix: Dynamic setting of min and max attributes using #text/#calc when field is hidden

= 1.10.81 - 03/20/2026 =
* Added: Improved license activation and check methods
* Changed: Removed dependency on mb_strtolower
* Changed: Session ID to Session Hash
* Bug Fix: Validation of Google address fields fixed when more than one field on a form

= 1.10.80 - 03/04/2026 =
* Added: Divi 5 module
* Added: QR code reading in Media Library field
* Added: Additional image mime types added for image conversion options in File Upload field
* Added: Send Email action now supports media capture as attachments
* Added: #checkbox_count now supports Price Checkbox fields
* Bug Fix: ACF taxonomy field type population

= 1.10.79 - 02/16/2026 =
* Added: CaptchaFox field type https://wsform.com/knowledgebase/captchafox/
* Bug Fix: Webhook data format for single select or checkbox selection

= 1.10.78 - 01/23/2026 =
* Added: Integration with the WP AI Client SDK https://github.com/WordPress/wp-ai-client
* Added: New "Make AI Request" action https://wsform.com/knowledgebase/make-ai-request-action/
* Added: New "Create from AI" form template https://wsform.com/knowledgebase/create-from-ai-template/
* Bug Fix: Conditional logic visibility action now runs validation

= 1.10.77 - 01/13/2026 =
* Bug Fix: Namespace fix for Breakdance form element

= 1.10.76 - 01/12/2026 =
* Added: PCP updates
* Bug Fix: Clear / reset help language text
* Bug Fix: Angie script enqueue args parameter

= 1.10.75 - 12/14/2025 =
* Bug Fix: Webhook select, checkbox, radio empty values

= 1.10.74 - 12/12/2025 =
* Bug Fix: Bootstrap tab progression
* Bug Fix: Webhook select, checkbox, radio undelimited format
* Bug Fix: Media capture fields return file name instead of full JSON object

= 1.10.73 - 12/06/2025 =
* Added: Include Fields setting on Summary field
* Bug Fix: Config select_cascade_no_match syntax error

= 1.10.72 - 12/04/2025 =
* Bug Fix: #email_log variable use outside of Send Email action
* Bug Fix: reCAPTCHA race condition

= 1.10.71 - 11/25/2025 =
* Bug Fix: WP_Filesystem move method called with overwrite flag to simulate PHP rename method

= 1.10.70 - 11/24/2025 =
* Bug Fix: Review nag fix (due to HTML escaping)

= 1.10.69 - 11/23/2025 =
* Added: WordPress 6.9 compatibility
* Added: Google Address Places API (New) fix to handle missing event firing when address selected
* Bug Fix: Template record counts

= 1.10.68 - 11/15/2025 =
* Added: IP throttling support for proxied addresses

= 1.10.67 - 11/11/2025 =
* Added: Additional updates to support WordPress MCP adapter (0.3.0) / Abilities API (0.4.0)
* Bug Fix: Google Address field Places API (New) custom attributes and Vacinity mapping

= 1.10.66 - 11/10/2025 =
* Added: Media Capture setting improvements

= 1.10.65 - 11/10/2025 =
* Added: Updates to support changes to WordPress MCP adapter (0.3.0) / Abilities API (0.4.0)
* Added: Improvement to tabs CSS
* Bug Fix: Form rendering in site editor

= 1.10.64 - 11/08/2025 =
* Added: PCP updates

= 1.10.63 - 10/25/2025 =
* Added: Media Capture field type
* Added: CIDR support for IP blocking
* Added: Improvements to Google Address field for Places API (New)
* Added: PCP updates
* Changed: Password strength JS library (zxcvbn) enqueue now uses WordPress copy
* Bug Fix: Select random option in debug console
* Bug Fix: Repeatable section delimiter usage and file objects in webhook action

= 1.10.62 - 10/23/2025 =
* Added: Some plugins call wp_footer more than once, added support for this scenario
* Bug Fix: Repeatable section delimiter usage in server-side #field variables

= 1.10.61 - 10/21/2025 =
* Added: wsf_footer_script_attributes filter hook https://wsform.com/knowledgebase/wsf_footer_script_attributes/
* Bug Fix: Footer scripts were rendered too soon for some page builders
* Bug Fix: Fix to KB slugs for local and session storage variables

= 1.10.60 - 10/19/2025 =
* Added: Integration with Angie Agentic AI https://wsform.com/angie-agentic-ai-meets-ws-form/
* Added: Integration with WordPress Abilities API: https://github.com/WordPress/abilities-api
* Added: Integration with WordPress MCP Server: https://github.com/Automattic/wordpress-mcp
* Added: Integration with Hostinger Reach: https://wordpress.org/plugins/hostinger-reach/
* Added: Initial set of abilities completed: https://wsform.com/knowledgebase/mcp-server/
* Added: Google Map fields can now be mapped to ACPT address fields
* Added: Public footer script now uses wp_add_inline_script
* Added: Improvements to help prevent field autofill software causing problems in layout editor
* Added: Improvements to Google Address usability on mobile
* Added: Improvements to email error handling
* Bug Fix: Caption font size for checkbox and radio fields
* Bug Fix: #field with delimiter now returns values back in original order
* Bug Fix: Fixed reference to #data_grid_row_wocommerce_cart in variables documentation

= 1.10.59 - 10/06/2025 =
* Added: Support for Google Maps JS 'Places API (New)' - Setting in WS Form > Settings > Advanced for accounts created after March 1st, 2025
* Added: Timeout and High Accuracy settings for browser geo lookup in Google Address field
* Added: Improved Google Maps JS API detection
* Added: #post_date_modified, #post_time_modified, #post_date_modified_custom and #post_parent variables
* Added: Demo post variable template
* Added: Sidebar resizing on submissions page
* Added: #field_max_value(id) now works for fields in repeatable sections
* Added: Improved switcher true / false detection for JetEngine
* Added: Improved admin CSS to handle body padding
* Added: Translator comment improvements
* Added: Translation language file updates
* Added: Ability to use tracking variables client-side, where available (e.g. #tracking_referrer)
* Added: Select2 theme setting
* Bug Fix: Function detection for captcha fields in conditional logic
* Bug Fix: Translation warnings during activation

= 1.10.58 - 09/11/2025 =
* Added: Resizable sidebar in layout editor
* Added: Improvement to ACPT data source to avoid errors if field ID changes / missing
* Added: Translation updates
* Bug Fix: Compiled rendering of layout CSS with RTL

= 1.10.57 - 09/04/2025 =
* Added: Abilities class ready for WordPress abilities / MCP APIs
* Added: Improve handling of visual builder includes
* Added: Options and style initialization on activation moved to init action
* Added: Accessibility improvements to Validation field
* Bug Fix: Various CSS calc() fixes
* Bug Fix: Spacer field markup in #email_submission
* Bug Fix: Invalid feedback for radio fields in a fieldset

= 1.10.56 - 08/27/2025 =
* Added: Upgrades for ACPT integration
* Bug Fix: #if variable string comparison

= 1.10.55 - 08/20/2025 =
* Added: E-commerce field lock / unlock methods for PayPal add-on
* Bug Fix: Conditional logic "Matches Field" condition case sensitivity
* Bug Fix: Currency formatting in submission e-commerce section
* Bug Fix: Submission date editing

= 1.10.54 - 08/15/2025 =
* Added: Form import (Button and drag & drop) on Add New form page
* Added: Improved presentation of unavailable settings in LITE edition
* Added: Improved base CSS for fields
* Bug Fix: TinyMCE focus scrolling

= 1.10.53 - 08/01/2025 =
* Added: wsf_action_email_css filter hook
* Added: Validate CSS improvements
* Added: Validation field update on invalid feedback set from Run WordPress Hook
* Added: include_hidden attribute on #checkbox_count and #checkbox_count_total variables
* Added: Summary field can now exclude HTML and Text Editor fields
* Added: Summary field no longer renders labels for HTML and Text Editor fields
* Added: Experimental searchable field mapping dropdowns
* Added: Updated Google Address field to support inconsistent address part types
* Bug Fix: Move down button

= 1.10.52 - 07/09/2025 =
* Added: New Validation field type (See: https://wsform.com/knowledgebase/validate/)
* Added: Additional checks when autofocusing select 2 search field
* Added: #section_id can now be used within #section_rows_start loop
* Added: Improvements to attachment filtering for DropzoneJS scratch files

= 1.10.51 - 06/27/2025 =
* Added: Improved server-side required validation
* Bug Fix: Migrate tool meta key validation

= 1.10.50 - 06/24/2025 =
* Added: New block using API version 3
* Added: Scroll and focus for invalid Visual Editor fields
* Bug Fix: Conditional logic highlighting
* Bug Fix: #field in data grid issue with multiple form instances

= 1.10.49 - 06/17/2025 =
* Bug fix: Akismet headers

= 1.10.48 - 06/09/2025 =
* Added: Email pattern setting now has "Must have TLD" example regex
* Added: wsf_name_prefixes and wsf_name_suffixes filter hooks for #name_prefix and #name_suffix variables
* Added: Updated translations
* Bug Fix: Radio and checkbox vertical padding removed if left label alignment selected
* Bug Fix: Edit in Preview link

= 1.10.47 - 05/22/2025 =
* Added: New #name_prefix(), #name_first(), #name_middle(), #name_last() and #name_suffix() variables (See: https://wsform.com/knowledgebase/extract-first-and-last-names-from-a-full-name/)
* Added: If you have a single form, submissions page now defaults to that form
* Added: Submissions page now remembers last form viewed
* Bug fix: Improved form_bypass_obj_reset method for resetting field prior to form_bypass

= 1.10.46 - 05/20/2025 =
* Removed: Human Presence as third party service no longer available

= 1.10.45 - 05/19/2025 =
* Added: Keyword blocklist string / word match options for wsf_submit_block_keywords filter hook
* Added: 404 returned on DropzoneJS scratch file attachment pages
* Changed: NONCE setting move to Spam Protection tab in Global Settings

= 1.10.44 - 05/17/2025 =
* Added: Keyword blocklist (See: https://wsform.com/knowledgebase/how-to-block-submissions-by-keyword/)
* Added: wsf_submit_block_keywords filter hook (See: https://wsform.com/knowledgebase/wsf_submit_block_keywords/)
* Added: IP blocklist (See: https://wsform.com/knowledgebase/how-to-block-form-submissions-by-ip/)
* Added: wsf_submit_block_ips (See: https://wsform.com/knowledgebase/wsf_submit_limit_ips/)
* Added: Cubic meter calculator template
* Added: Send email action now accepts BCC or CC in isolation
* Added: Improvement to #slug variable
* Bug Fix: Performance improvement with reading CSS option

= 1.10.43 - 05/12/2025 =
* Bug Fix: Mouse up handler in layout editor

= 1.10.42 - 05/09/2025 =
* Added: #field_date_age variable that can be used to calculate age from a date field
* Added: Label translation settings for the DropzoneJS file upload component
* Added: form_bypass reset on conditional logic required set
* Added: Improvements to option_set and option_get methods

= 1.10.41 - 05/06/2025 =
* Added: Additional checks for number formatting to ensure decimals are between 0 and 100
* Bug Fix: Bypass hidden field check if hidden at a section or tab level
* Bug Fix: form_bypass on cascade

= 1.10.40 - 05/04/2025 =
* Added: field_<field_id> and field_values parameters to WS Form short code for populating field values (See: https://wsform.com/knowledgebase/the-ws-form-shortcode/)
* Added: Message shown when copying shortcodes in admin sidebar
* Bug Fix: form_bypass custom validation caching now checks for validity.customError set on element

= 1.10.39 - 05/01/2025 =
* Bug fix: Captcha key obscuring admin side

= 1.10.38 - 04/30/2025 =
* Added: Improved admin config handling
* Added: Improved price checkbox and price radio hidden row handling
* Bug fix: form_bypass on min / max character length check if field hidden

= 1.10.37 - 04/24/2025 =
* Bug Fix: Checkbox and radio row data IDs

= 1.10.36 - 04/23/2025 =
* Bug Fix: Added capability check to config API endpoint

= 1.10.35 - 04/17/2025 =
* Added: data-id attribute added to data grid checkbox and radio field rows
* Bug Fix: Hierarchy indentation CSS for checkbox and radio fields
* Bug Fix: aria-hidden attribute on invalid feedback text
* Bug Fix: form_bypass row referencing

= 1.10.34 - 04/10/2025 =
* Bug Fix: Radio / checkbox field hidden bypass
* Bug Fix: pre_render filter hook no longer runs for styler preview template

= 1.10.33 - 04/08/2025 =
* Bug Fix: Conditional multi-event triggers

= 1.10.32 - 04/07/2025 =
* Bug Fix: Tab click detection in conditional logic
* Bug Fix: Cascade AJAX handle reset

= 1.10.31 - 04/04/2025 =
* Added: Summary field type
* Added: Insert summary HTML button for HTML field
* Added: Webhook array to CSV delimiter setting
* Added: Is Blank setting for redirect fallback
* Added: Data layer conversion reset setting
* Added: Webhook username and password fields can now contain WS Form variables
* Added: Improved client-side REST API response handling
* Added: Patched datetime library with latest verion for date formatting library
* Added: Styler settings for repeatable section icons
* Added: Debug console CSS improvements
* Added: Various styler CSS improvements
* Added: Updated translations
* Added: Google Address location snap setting for Google Maps
* Added: Various improvements to licensing class
* Added: WordPress 6.8 compatibility
* Bug Fix: Google Maps being set from Google Address / Routing in repeaters
* Bug Fix: Checkbox row level data-hidden attribute causing field to submit empty
* Bug Fix: Email validation if Multiple checkbox enabled
* Bug Fix: Action firing via conditional logic

= 1.10.30 - 03/20/2025 =
* Added: Repeaters to arrays setting in Webhook action

= 1.10.29 - 03/19/2025 =
* Added: Additional Google Map parameters stored in address object for ACF
* Bug Fix: Server-side #field data grid column mapping fix for repeaters / duplicate values

= 1.10.28 - 03/18/2025 =
* Added: Patch to fix form select option values bug with Divi
* Added: Translation improvements for product names
* Bug Fix: Admin toolbar menu fix if no supported user capabilities found

= 1.10.27 - 03/12/2025 =
* Added: Warnings added to fields if hidden is checked to explain how hidden fields work
* Added: Form list table now shows orange switches and text if a form publish is pending
* Added: Auto publish setting
* Added: JetEngine options pages support

= 1.10.26 - 03/08/2025 =
* Added: Legacy support for invalid feedback fields in layout CSS file

= 1.10.25 - 03/08/2025 =
* Bug Fix: Coloris fix for LITE

= 1.10.24 - 03/07/2025 =
* Added: Updated detection script for Meta Box and ACPT custom field plugins
* Added: Improved help text for file upload Accepted File Type(s) setting
* Added: Field border placement setting in styler (All sides or bottom only)
* Changed: Invalid feedback CSS moved from layout to base CSS files
* Bug Fix: Invalid feedback positioning if prefix / suffix and ITI used on phone field

= 1.10.23 - 03/03/2025 =
* Added: Patch to fix browser related bug for DropzoneJS hidden input field when rendered using RTL
* Bug Fix: Post data source fix if Meta Box returned an object instead of an array
* Bug Fix: CSS fix for checkbox styled as button with full width

= 1.10.22 - 02/26/2025 =
* Added: Admin CSS improvements
* Added: Improved ACF required field handling
* Added: Meta box data source object bypassing
* Bug Fix: Conversation JS no longer enqueued if dynamic enqueuing is disabled
* Bug Fix: #checkbox_count fix

= 1.10.21 - 02/19/2025 =
* Added: Clamp font size calculator (https://theadminbar.com/simple-responsive-font-size-calculator/)
* Added: #option_get(option_name, parameter/key) variable for use in action settings
* Added: Email address field added to cascading source field types
* Added: Updated language files
* Added: Patched bug with intl-tel-input library returning error -99
* Added: Various CSS improvements
* Changed: Default p bottom margin change to 1em (browser default)
* Changed: Updated Coloris CDN paths

= 1.10.20 - 02/12/2025 =
* Added: Social Security Number field type https://wsform.com/knowledgebase/ssn/
* Added: #checkbox_count_total (Total checkboxes in field) and #select_count_total (Total options in field) variables
* Added: Various styler CSS improvements
* Bug Fix: Home URL referencing

= 1.10.19 - 02/08/2025 =
* Added: Improvements to server-side email address validation
* Changed: Some server-side checks now return an HTTP 403 status code to avoid error emails being sent

= 1.10.18 - 02/07/2025 =
* Added: New functionality added for OpenAI generated calculator forms
* Bug fix: Loader CSS enqueuing

= 1.10.17 - 02/05/2025 =
* Added: Fallback URL setting in Redirect action https://wsform.com/knowledgebase/redirect-users-to-the-referring-page-after-login/
* Bug Fix: Woocommerce cart rendering for select, checkbox or radio fields in repeaters

= 1.10.16 - 01/31/2025 =
* Added: TrustedForm support https://wsform.com/knowledgebase/trustedform/
* Added: Default reCAPTCHA version setting in global settings
* Added: Third party custom field changes ready for Option Management add-on
* Added: Stopped tutorial rendering if IntroJS incorrectly enqueued by third party plugins
* Bug Fix: Date/time overlay styling if outside of wrapper

= 1.10.15 - 01/22/2025 =
* Bug Fix: Submission unread bubble escaping
* Bug Fix: Client-side wpautop now checks for non-string input

= 1.10.14 - 01/21/2025 =
* Added: Changes made to form populate sidebar ready for Salesforce add-on improvements
* Added: URL, email and tel outputs no longer anchored if invalid
* Added: Improved escaping throughout
* Added: Changed randomness of debug console hostname generator

= 1.10.13 - 01/20/2025 =
* Added: Improvement to Coloris color picker to ensure it updates if vars entered
* Added: Added height auto on fields to overcome third party CSS fixing heights
* Added: Improved input sanitization of URL and tel fields
* Bug Fix: WordPress media selector disable in visual editor enqueuing to avoid conflicts with ACF

= 1.10.12 - 01/15/2025 =
* Added: Improvements to checkbox and radio field overrides to avoid third party CSS issues
* Bug Fix: Framework fix in visual editors

= 1.10.11 - 01/14/2025 =
* Added: Improvements to CSS overrides for checkbox and radio fields
* Added: Set custom validity on data grid rows in conditional logic
* Bug Fix: CSS fixes for Bootstrap 5

= 1.10.10 - 01/13/2025 =
* Added: Circle style option for radio fields
* Added: Border radius style setting for checkboxes (inherits field border radius by default)
* Added: Styler palette now resolves CSS variables to colors from theme palettes
* Added: Improvements to styler LITE and PRO preview templates
* Bug Fix: Invalid feedback styling for field level validation
* Bug Fix: Meta Box time field population
* Bug Fix: Checkmark positioning in checkbox fields related to border width

= 1.10.9 - 01/10/2025 =
* Added: Background color styler setting added for signature field
* Added: Persistent debug and styler CSS enqueuing
* Bug Fix: Action disabling if all actions disabled with conditional logic

= 1.10.8 - 01/08/2025 =
* Added: Inside label position behavior setting to styler
* Added: ACF fields now exclude option assign fields by default
* Added: Message styling added to LITE edition
* Bug Fix: Removed PHP warning in version prior to 8.0 related to style template SVG's
* Bug Fix: Submission export for LITE edition

= 1.10.7 - 01/07/2025 =
* Added: Improved compatibility of new form components with visual builders

= 1.10.6 - 01/06/2025 =
* Bug Fix: Customize publish button issue when wsf_styler_enabled filter set to true

= 1.10.5 - 01/05/2025 =
* Added: Improvements to style preview templates
* Changed: Date/time field day padding reduced to improve size on mobile
* Changed: CSS value sanitization now accepts zero without unit
* Bug Fix: WooCommerce form locking
* Bug Fix: wsf_styler_enabled filter hook
* Bug Fix: Checkbox and radio disabled opacity

= 1.10.4 - 01/04/2025 =
* Bug Fix: Remove width setting on buttons

= 1.10.3 - 01/02/2025 =
* Added: InstaWP staging install support

= 1.10.2 - 01/02/2025 =
* Bug Fix: Removed descending index for style table to avoid incompatibility issues with some storage engines

= 1.10.1 - 01/02/2025 =
* Bug Fix: Activation debug disabled

= 1.10.0 - 01/02/2025 =
* Important installation notes: https://wsform.com/knowledgebase/upgrade-notes-for-1-10-x/
* Added: New form styles (See: https://wsform.com/knowledgebase/styles/)
* Added: New form styler (See: https://wsform.com/knowledgebase/styler/)
* Added: Accessibility improvement: autocomplete attributes now default for password, URL, email and phone fields
* Added: Accessibility improvement: autocomplete attributes completed in form and section templates
* Added: Accessibility improvement: Checkbox field now defaults to label on
* Added: Accessibility improvement: Removed character / word count help text from textarea by default
* Added: Accessibility improvement: URL field now contains https:// placeholder
* Added: Accessibility improvement: Color contrast improvements throughout
* Added: Accessibility improvement: Coloris color picker
* Added: Accessibility improvement: ARIA label on section fieldsets
* Added: Accessibility improvement: Dark / light color themes
* Added: Auto grow setting for Text Area field
* Added: Checkbox and radio styling setting (button, switch, swatch and image)
* Added: Email allow / deny feature now processed client-side
* Added: Improved Dutch translations
* Added: Increased generated password size to 24 characters
* Added: Form saved on field clone
* Added: Support for j.n.Y date format
* Added: Submission export performance improvements
* Added: Descriptive form limit error message on form submit
* Added: Select2 upgraded to version 4.0.13
* Added: WordPress 6.7 compatibility testing
* Added: Author ID added as column in Posts data source
* Added: Points allocation form template
* Added: Repeater level custom attachment title, excerpt, content and alt text
* Added: Updated logo in conversation template
* Added: Postmark API error handling in Send Email action
* Added: #query_var default value parameter
* Added: Limit submissions per logged in user
* Added: Invalid captcha responses no longer throw a PHP exception
* Added: Phone field ITI validation triggered on paste event
* Added: Additional checks when determining capabilities for conditional logic
* Bug Fix: Loader functionality on form reload
* Bug Fix: Translation issue related to widgets_init / load_plugin_textdomain
* Bug Fix: Escaping when using #text
* Bug Fix: Price radio invalid feedback text location
* Bug Fix: Order by in terms data source for term order
* Bug Fix: Form calc clean method for hidden fields

= 1.9.249 - 11/12/2024 =
* Added: WordPress 6.7 compatibility testing

= 1.9.248 - 11/06/2024 =
* Bug Fix: Fix to submission view types

= 1.9.247 - 11/06/2024 =
* Bug Fix: Fix to submission view values

= 1.9.246 - 11/05/2024 =
* Added: #date_format variable
* Bug Fix: CSS security fix

= 1.9.245 - 08/29/2024 =
* Added: Form statistics performance improvements
* Added: Copy to clipboard action in conditional logic
* Added: Divi reCAPTCHA patch
* Bug Fix: Search action capabilities fix
* Bug Fix: JetEngine blank date fix for timestamps

= 1.9.244 - 08/21/2024 =
* Bug Fix: ISO 8601 formatted date 'c'
* Bug Fix: ITI phone number validation (For error -99)
* Bug Fix: XSS security fix for nested HTML tags

= 1.9.243 - 08/19/2024 =
* Added: Date / time picker pop-up class
* Changed: Date regex examples
* Bug Fix: Settings license page translation
* Bug Fix: Google routing waypoint initial event firing

= 1.9.242 - 08/13/2024 =
* Added: Field sort support for SQLite
* Bug Fix: Form bypass method

= 1.9.241 - 08/07/2024 =
* Added: Setting in file upload field that allows files to be uploaded to Media Library upload path
* Added: Fathom conversion event can now include WS Form variables
* Added: $temp_path added to wsf_action_email_attachments filter hook
* Added: Improved capabilities checks for customize tool
* Added: get_header method added to WS_Form_Submit_Export class
* Bug Fix: Required field string translation

= 1.9.240 - 08/02/2024 =
* Bug Fix: Progress bar in Bootstrap framework

= 1.9.239 - 07/31/2024 =
* Added: RTL support for the Send Email action
* Bug Fix: Conditional logic bug fix

= 1.9.238 - 07/29/2024 =
* Added: Google Address field validation to ensure a valid address has been selected (Enabled by default, but can be disabled in Advanced > Validation)
* Added: Improved message return action handling for Run WordPress Hook action
* Added: cookie_set return action added Run WordPress Hook action
* Bug Fix: Conditional logic sidebar no longer jumps when adding new conditions
* Bug Fix: Data grid import if ID's are blank
* Bug Fix: Repeat form submission user duration tracking
* Bug Fix: Capability check on db_draft method

= 1.9.237 - 07/26/2024 =
* Bug Fix: Redirect on Run WordPress Hook

= 1.9.236 - 07/26/2024 =
* Added: Ability to use #field in repeaters for custom filenames in File Upload field
* Added: Updated Divi form selector code
* Changed: Default form font size changed to 16px to improve accessibility
* Bug Fix: Fixed date / time handling in Metabox date field population
* Bug Fix: Date field initial validation

= 1.9.235 - 07/22/2024 =
* Bug Fix: Fix for Bricks styler

= 1.9.234 - 07/22/2024 =
* Added: Variable helper added to conversion tracking action
* Bug Fix: Permission error on Save Submission auto expiry cron job

= 1.9.233 - 07/22/2024 =
* Bug Fix: Visual builder form list population

= 1.9.232 - 07/21/2024 =
* Added: Integraton support for DataKit https://www.datakit.org/
* Added: Quizzes form template category
* Change: Submissions form selector now only shows forms with submissions

= 1.9.231 - 07/19/2024 =
* Bug Fix: Action variable parsing

= 1.9.230 - 07/19/2024 =
* Added: Support for object return data from Salesforce
* Bug Fix: Removed empty elements in parse variable lookup table

= 1.9.229 - 07/18/2024 =
* Added: New variable helper modal accessible from the # icon in the sidebar
* Added: WordPress 6.6 compatibility testing
* Bug Fix: Akismet agent parameter

= 1.9.228 - 07/15/2024 =
* Bug Fix: Parse variables date fixes

= 1.9.227 - 07/15/2024 =
* Bug Fix: Client-side date translation

= 1.9.226 - 07/14/2024 =
* Bug Fix: Conversational progress bar adjusted to use default max value of 1

= 1.9.225 - 07/13/2024 =
* Bug Fix: Google Tag Manager gtm.formSubmit element parameter compatibility issue with input mask component

= 1.9.224 - 07/12/2024 =
* Added: Referrer URL added to error emails
* Added: UK sort code regex pattern to examples dropdown and form template
* Bug Fix: Migrate function image processing
* Bug Fix: Removed conditional events from rating field that don't fire
* Bug Fix: Cloudflare Turnstile timeout message

= 1.9.223 - 07/05/2024 =
* Added: PHP 8.3 compatibility checks
* Added: Post data source parent post ID setting
* Added: Upgraded Google map marker to use AdvancedMarkerElement class
* Changed: Google map styling now uses Map ID and cloud styling (Required for AdvancedMarkerElement upgrade)
* Bug Fix: Improved Google map loaded handling
* Bug Fix: Updated customizer help text
* Bug Fix: Updated encryption library to remove deprecated messages
* Bug Fix: Updated Breakdance element to remove deprecated function

= 1.9.222 - 06/26/2024 =
* Added: Support for JetEngine fields using Post, User and Term queries in JetEngine data source

= 1.9.221 - 06/23/2024 =
* Added: Improved Progress demo template
* Added: Progress percentage forced rounding to improve presentation of custom values
* Changed: Progress field now defaults max to 1 instead of 100 to comply with HTML spec

= 1.9.220 - 06/17/2024 =
* Added: Improved #calc processing
* Changed: WS Form dashboard widget now requires read_submission and read_form capabilities
* Bug Fix: HTML stripping removed from textarea when using #calc or #text
* Bug Fix: Progress bar when max set to value other than 100
* Bug Fix: Implemented workaround for jQuery mobile causing invalid and valid pseudo classes to fail
* Bug Fix: message_hide parameter on Run WordPress Hook when using message action

= 1.9.219 - 06/12/2024 =
* Added: Additional debug output for reCAPTCHA HTTP request failures
* Bug Fix: PHP 7.2 sprintf issue

= 1.9.218 - 06/05/2024 =
* Added: Mark as Read setting on Save Submission setting
* Added: OWASP guideline compliance for CSV exports: https://owasp.org/www-community/attacks/CSV_Injection

= 1.9.217 - 06/01/2024 =
* Added: Improved performance of tracking variables
* Bug Fix: #email_tracking

= 1.9.216 - 06/01/2024 =
* Bug Fix: Select default value via pre_render hook

= 1.9.215 - 05/31/2024 =
* Added: Full URL and hash options added to tracking
* Bug Fix: Metabox taxonomy advanced field type fix
* Bug Fix: Radio validation selector

= 1.9.214 - 05/28/2024 =
* Added: Webhook "Process Response" setting
* Added: Webhook wsf_action_webhook_http_headers and wsf_action_webhook_http_payload filter hook
* Added: #hash_md5 and #hash_sha256 server-side variables
* Added: Improved error email handling
* Bug Fix: Typo in Membership Application form template
* Bug Fix: Hidden field change event firing in conditional logic

= 1.9.213 - 05/21/2024 =
* Added: Improved handling of default max file upload setting
* Added: Webhook response added to debug console log
* Added: Improvements to system table in settings

= 1.9.212 - 05/19/2024 =
* Added: Form level invalid feedback text setting
* Added: Webhook response code mapping setting
* Added: Updated translations
* Changed: Default invalid feedback message changed to "This field is required."
* Bug Fix: Radio invalid feedback positioning when using horizontal orientation

= 1.9.211 - 05/17/2024 =
* Bug Fix: Double HTML encoding issue with #text
* Bug Fix: Akismet integration fix

= 1.9.210 - 05/14/2024 =
* Bug Fix: Radio field accessibility handling in conversational forms

= 1.9.209 - 05/13/2024 =
* Added: Always Visible setting on Loader
* Added: Improved Always Visible position calculations
* Added: street-address auto complete option added to Text fields
* Added: ACPT Country field type support
* Bug Fix: Signature processing for Media Library handler

= 1.9.208 - 05/07/2024 =
* Added: ACPT integration support for Post Management (1.6.0) add-on
* Added: ACPT integration support for User Management (1.6.0) add-on
* Added: ACPT data source
* Added: Pattern testing template
* Added: Accessibility improvement for radio fields on conversational forms
* Changed: Pods file handler now uses media library
* Changed: LITE support requests now directed to wordpress.org support forum
* Changed: #acf_repeater_field variable discontinued in favor of Post Management add-on
* Bug Fix: Debug population of number fields with min, max and step
* Bug Fix: Various updates to accommodate braking changes in ITI library
* Bug Fix: Conversational form vertical scrolling on focussed fields

= 1.9.207 - 04/29/2024 =
* Added: Inline validation "On field change / blur" setting that will only show inline validation after a field is changed
* Added: Set custom validation conditional action for rating field
* Bug Fix: ITI default country

= 1.9.206 - 04/22/2024 =
* Changed: Event property when determining source DOM element

= 1.9.205 - 04/21/2024 =
* Bug Fix: Removed debug from wsf_field_get_objects function

= 1.9.204 - 04/20/2024 =
* Bug Fix: Fix to WS Form event firing

= 1.9.203 - 04/20/2024 =
* Added: PHP functions to retrieve submit value by field class name (https://wsform.com/knowledgebase_category/php-functions/)
* Added: Fathom conversion tracking value now supports WS Form variables
* Added: Exclude Blank Parameters setting in Redirect action for query string parameters
* Added: Checkboxes can now be unchecked with conditional logic if disabled
* Bug Fix: Conditional event firing

= 1.9.202 - 04/16/2024 =
* Added: Focus conditional action for rating fields
* Added: Dragend event for Google Address map geolocate
* Changed: Conversational form error alerts now positioned above nav to improve legibility
* Bug Fix: Loader sprite color

= 1.9.201 - 04/14/2024 =
* Added: Loader now always visible automatically regardless of form height
* Added: New min / max variables for series of fields (See: https://wsform.com/knowledgebase/calculating-minimum-and-maximum-field-attributes/)
* Added: Toggle for enabling geolocate on load for Google Address field
* Added: New condition to run geolocate on Google Address field
* Added: Gelocate on click setting for map associated with Google Address field
* Added: Geolocate event under loader settings

= 1.9.200 - 04/11/2024 =
* Added: WordPress 6.5 compatibility testing
* Added: Google Address field auto complete by browser location or IP lookup
* Added: #file_repeater_index for custom file names
* Bug Fix: RTL CSS fixes
* Bug Fix: Select2 population by array

= 1.9.199 - 03/24/2024 =
* Added: ACF meta mapping in post data source now outputs as formatted value
* Bug Fix: Row population in submission admin page
* Bug Fix: Small typo in WordPress block

= 1.9.198 - 03/18/2024 =
* Added: Default value setting on select, checkbox and radio fields

= 1.9.197 - 03/17/2024 =
* Added: Transform on email field

= 1.9.196 - 03/03/2024 =
* Bug Fix: Date handling in custom field integrations when populating a form

= 1.9.195 - 03/01/2024 =
* Bug Fix: Updated ITI flag images

= 1.9.194 - 02/29/2024 =
* Added: #acos, #asin, #atan variables
* Added: Update ITI libary
* Added: wsf_form_checksum_check filter hook
* Added: #calc performance improvement by reducing duplicate calculations
* Changed: Removed transform setting on email field due to incompatibility
* Bug Fix: Repeatable section changes breaking #calc array
* Bug Fix: Fix to #calc handling of price range fields

= 1.9.193 - 02/12/2024 =
* Added: Support for Save on WooCommerce product with variations
* Bug Fix: Progress calculation for checkbox fields with min / max parameters
* Bug Fix: Submissions page selector
* Bug Fix: JetEngine data source when using glossary

= 1.9.192 - 02/08/2024 =
* Bug Fix: Meta data generation when creating form from action.

= 1.9.191 - 02/07/2024 =
* Bug Fix: Run JavaScript action

= 1.9.190 - 02/07/2024 =
* Bug Fix: Minor code change in submit classes to maintain compatibility with EOL PHP versions

= 1.9.189 - 02/05/2024 =
* Added: wsf-tab-clicked event
* Added: New functionality required for Webex integration
* Added: Improved Italian translations
* Bug Fix: Field level deduplication issue
* Bug Fix: Run JavaScript actions would fail if a comment was present at the end

= 1.9.188 - 02/01/2024 =
* Added: Google Address Test template that includes all mappings
* Added: Performance improvement in editor when outputting section template JSON
* Bug Fix: wsf_submit_validate now only runs once per form submit

= 1.9.187 - 01/27/2024 =
* Added: Improved checking of API key for Google field types
* Bug Fix: Time formatting fix in emails

= 1.9.186 - 01/22/2024 =
* Added: Limit by IP in Form Settings
* Bug Fix: Select2 cascade enqueue warning

= 1.9.185 - 01/21/2024 =
* Added: Submission error email notifications
* Added: Sortable setting on file upload field for DropzoneJS multiple configuration
* Added: Google address field now has same conditional logic options as text fields
* Added: Convert arrays to strings if mapped custom field is string based
* Added: wsf_submit_validate to compliment wsf_submit_field_validate filter hook
* Added: Bulk action in data grid now retains checked rows to make toggling features on and off easier
* Bug Fix: Week date format in emails
* Bug Fix: Translated dates in email_submission

= 1.9.184 - 01/16/2024 =
* Added: Bulk select CSV Export in submissions now uses paged process to improve performance

= 1.9.183 - 01/16/2024 =
* Bug Fix: Submission export paging

= 1.9.182 - 01/15/2024 =
* Added: Improved debug console population of first and last name fields using library of names
* Added: Improved debug console population of emails with first and last name and more random domain name
* Added: Improved debug console population of select and checkboxes with support for multiple, min and max settings
* Added: Get Data in Data Sources now clears last error log if successful
* Added: Improved template file error handling
* Changed: Number step setting moved to basic tab with improved help text
* Changed: Improvements to submission filtering and exporting code
* Changed: Removed Hidden setting from captcha fields due to misinterpration
* Changed: Tag Mapping to Term Mapping in Form Settings > Data > Populate Using Action
* Bug Fix: Submissions export with date filters applied in languages other than English
* Bug Fix: Required checkbox rows now excluded from validation if hidden
* Bug Fix: Clear button on signatures if prefix applied to field

= 1.9.181 - 01/07/2024 =
* Added: Conversion Tracking action now support Bento JavaScript events
* Added: Conditional action for increasing / decreasing numeric based field values by a given step or WS Form variable
* Added: Cloudflare Turnstile size and appearance settings
* Added: Updated French translations

= 1.9.180 - 01/04/2024 =
* Added: Google map auto centering options (By browser or IP geo lookup)
* Bug Fix: Workaround implemented for PHP ZEND_FETCH_DIM_RW bug (Not a WS Form bug)
* Bug Fix: Cookie decodeURIComponent handling
* Bug Fix: Phone field now has inputmode="tel" attribute to ensure input make library does not break keyboard on mobile
* Bug Fix: Deduplication functionality now only checks submissions with a status of publish

= 1.9.179 - 12/27/2023 =
* Added: Submissions keyword search
* Added: Improved error handling for cookie and query string parsing
* Bug Fix: Conditional logic case sensitivity on select, checkbox and radio value conditions

= 1.9.178 - 12/17/2023 =
* Added: Ignore empty key value setting in Webhook action
* Added: Improved debug toggle script enqueuing
* Added: Defer setting for enqueued JavaScript
* Added: wsf_enqueue_script_strategy_defer and wsf_enqueue_script_in_footer filter hooks
* Added: Disable translation setting to force English (US)
* Added: Test All Fields template in Demos
* Bug Fix: Legal field with progress

= 1.9.177 - 12/10/2023 =
* Added: Performance improvement on preset loading and submit variables
* Added: Transform functionality now retains cursor position
* Added: Flush rewrite on welcome screen to improve REST API availability on new installs
* Bug Fix: Action repair on import
* Bug Fix: Case sensitive fix on Selected Value Equals condition
* Bug Fix: Typo in form import modal

= 1.9.176 - 11/26/2023 =
* Added: Support for Fathom Analytics in the Conversion Tracking action
* Added: Ability to enable and disable the debug console from the admin bar menu
* Added: Date From / To template in section library
* Added: Link to Files setting in global settings that allows file links in PDF templates
* Changed: Endpoint updated for ipapi.co
* Bug Fix: Inline validation when using tab validation

= 1.9.175 - 11/19/2023 =
* Added: Accessibility improvements - aria-invalid, aria-describedby for select and textarea fields

= 1.9.174 - 11/18/2023 =
* Added: Accessibility improvements - aria-invalid, aria-describedby for inputs
* Added: field_value action added to Run WordPress Hook action
* Bug Fix: Inside label offset calculations on fields with prefix now assessed when field is shown

= 1.9.173 - 11/16/2023 =
* Added: wsf_enqueue_scripts and wsf_enqueue_styles action hooks for enqueuing custom CSS or JavaScript when a form is present on a page
* Added: From address is now optional for Send Email action
* Added: Help text added to progress fields for Bootstrap and Foundation frameworks
* Bug Fix: Loader CSS was not enqueued if dynamic enqueuing was disabled

= 1.9.172 - 11/01/2023 =
* Added: New #submit_date_added and #submit_date_added_custom("format") variables
* Added: New wsf_submit_export_csv_header and wsf_submit_export_csv_row filter hooks
* Added: Default row set for ACF and Meta Box custom field data source
* Added: User Ratings Total mapping added for Google Address field
* Added: Save button in form label when focussed
* Bug Fix: Action setting direct numeric setting replacement during import
* Bug Fix: Undo meta key issue
* Bug Fix: wpautop on submissions in edit mode

= 1.9.171 - 10/25/2023 =
* Bug Fix: PHP 8.2 compatibility support
* Bug Fix: Admin form view order and orderby query variables now limited to fixed values to improve security

= 1.9.170 - 10/25/2023 =
* Added: New #tracking_duration variable for returning the time it took to submit the form in seconds

= 1.9.169 - 10/19/2023 =
* Added: New #field_count_char(id, "regex_filter") variable for returning the number of characters in a string
* Added: New #field_count_word(id, "regex_filter") variable for returning the number of words in a string
* Added: New "All rows selected" and "Not all rows selected" conditional logic IF conditions for select fields
* Added: New "All rows checked" and "Not all rows checked" conditional logic IF conditions for checkbox fields

= 1.9.168 - 10/11/2023 =
* Bug Fix: Row specific conditional logic

= 1.9.167 - 10/10/2023 =
* Added: Improved conditional logic debug logging
* Added: Improved syntax error output when evaluating variables
* Added: Improved handling or conditional logic select, checkbox and radio row handling
* Changed: DropzoneJS default placeholder text

= 1.9.166 - 10/04/2023 =
* Added: Improved handling of sidebar default values in admin
* Added: Changed captcha resetting to only occur on form submit

= 1.9.165 - 09/30/2023 =
* Bug Fix: Class meta key used on file and password fields

= 1.9.164 - 09/29/2023 =
* Bug Fix: Fields with suffix had formatting issue with new help text system

= 1.9.163 - 09/29/2023 =
* Added: Help text positioning (Top or bottom) that can be set at a form or field level

= 1.9.162 - 09/23/2023 =
* Added: Google routing field waypoint support
* Added: Cascade source now supports hidden fields
* Added: WordPress plugin standards compliance improvements
* Bug Fix: #file_index on custom file names

= 1.9.161 - 09/19/2023 =
* Added: New priority for Run WordPress Hook action: Before submission created
* Bug Fix: Number field step attribute when hidden

= 1.9.160 - 09/17/2023 =
* Added: Clear and reset conditional logic options for cart price fields
* Added: Improved handling of embedded variables in attributes on server-side

= 1.9.159 - 09/16/2023 =
* Added: File upload image restrictions for image max width and max height
* Added: File upload image restrictions now shown against each file when using DropzoneJS
* Added: Debug console populate function now obeys input masks
* Added: wsf_loaded hook
* Added: Form import now strips BOM if found
* Bug Fix: Debug console populate date fields with min / max ranges
* Bug Fix: Input mask enqueuing for currency if only cart detail / cart total fields present

= 1.9.158 - 09/13/2023 =
* Added: File upload image restrictions for image width, height and aspect ratio
* Added: Form limits without message types no support server-side WS Form variables

= 1.9.157 - 09/07/2023 =
* Added: Form limit messages now support server-side WS Form variables
* Bug Fix: ACF radio and button group meta value

= 1.9.156 - 09/06/2023 =
* Bug Fix: ACF post object mapping meta value

= 1.9.155 - 09/05/2023 =
* Added: ACF field validation override if validation filters return invalid response.
* Bug Fix: Phone field inside label positioning if ITI configured to use country code selector

= 1.9.154 - 08/23/2023 =
* Added: gtag automatically exposed to dataLayer for Google Tag Manager implementations
* Added: Legal field calculation improvements
* Added: Privacy improvements with author variables
* Bug Fix: Server-side Belgian French date translations
* Bug Fix: Conversational date picker

= 1.9.153 - 08/21/2023 =
* Added: Google Tag Manager (Data Layer) conversion type that only runs dataLayer.push(params)

= 1.9.152 - 08/18/2023 =
* Added: Custom attributes for hidden fields
* Added: Accessibility improvements in the layout editor (Improved color contrasts and ARIA attribute review)
* Added: Reduced page size when exporting submissions to reduce server memory usage
* Bug Fix: Language string issue when clicking to add fields

= 1.9.151 - 08/14/2023 =
* Added: Support for GA4 Enhanced Event Measurement form_start & form_submit events

= 1.9.150 - 08/09/2023 =
* Added: Added InstaWP to LITE readme.txt
* Bug Fix: Select2 default option preload in admin sidebar

= 1.9.149 - 08/08/2023 =
* Added: WordPress 6.3 compatibility testing
* Added: Additional functionality added to action form engine for InstaWP add-on

= 1.9.148 - 08/03/2023 =
* Bug Fix: Conditional logic on fields within repeatable sections with a source outside of a repeatable section

= 1.9.147 - 08/03/2023 =
* Added: Conditional logic actions for loader
* Added: Form instance style targeting for loader

= 1.9.146 - 08/02/2023 =
* Added: Loader / spinner system for form submit, save, action and render events
* Added: Debug console color improvements
* Bug Fix: Webhook custom mapping on legacy data
* Bug Fix: Signature resize event if hidden
* Bug Fix: Required indicator on legal field

= 1.9.145 - 07/28/2023 =
* Bug Fix: ACF custom field column mapping in posts data source

= 1.9.144 - 07/27/2023 =
* Bug Fix: Selector escaping in admin

= 1.9.143 - 07/26/2023 =
* Added: Session hash now automatically clears if the associated submission record has been trashed
* Added: Improved text area formatting in submissions sidebar
* Added: Improved JS selector escaping throughout
* Added: Post data source now supports reading field data contained within a group
* Bug Fix: If a tab is clicked using conditional logic it now shows the tab to ensure the fields are submitted

= 1.9.142 - 07/22/2023 =
* Added: Cascading select fields configured to use AJAX can now be pre-populated
* Added: Improved German translations in debug console
* Added: ID deduplication during data grid CSV import
* Added: Improved scroll detection for legal field

= 1.9.141 - 07/19/2023 =
* Added: Geolocation Lookup by IP in Form Settings that allows you to populate fields with gelocation data such as city and region
* Added: Two additional IP lookup endpoints; ipinfo.io and ipapi.co
* Added: Setting to include admin traffic in statistics data added to Basic tab of Global Settings

= 1.9.140 - 07/11/2023 =
* Bug Fix: Escaping issue in admin sidebar for disabling unique values in mapping repeaters

= 1.9.139 - 07/08/2023 =
* Added: Ability to set license keys using a named constant in wp-config.php https://wsform.com/knowledgebase/setting-license-keys-with-php-constants/

= 1.9.138 - 07/06/2023 =
* Added: AI generated form support for OpenAI add-on
* Added: Updated DropzoneJS to version 5.9.3
* Bug Fix: data-hidden-bypass fix

= 1.9.137 - 07/04/2023 =
* Bug Fix: Running calculations when repeatable section is moved up or down

= 1.9.136 - 07/03/2023 =
* Added: JetEngine checkbox data format updates

= 1.9.135 - 07/03/2023 =
* Added: Ability to use the form locate feature when using Bricks site builder
* Bug Fix: JetEngine user field options

= 1.9.134 - 06/29/2023 =
* Added: Support for non-English dates in submission date range search
* Added: Add Media button toggle for the visual editor text area type, only visible to logged in users with the upload_files capability
* Bug Fix: Initial tab validation if conditions existed

= 1.9.133 - 06/26/2023 =
* Added: Removed fonts.googleapis.com dependency in admin CSS
* Bug Fix: CSS for template SVG's enqueuing incorrectly

= 1.9.132 - 06/23/2023 =
* Added: Multiple setting for Radio fields in IF conditions
* Added: Paste as Text setting for text area visual editor to determine default state of Paste as Text button
* Added: Hooks to customize text area visual editor buttons https://wsform.com/knowledgebase/customize-the-visual-editor-toolbar/
* Bug Fix: Removed form-control class around captcha fields for Bootstrap 5

= 1.9.131 - 06/20/2023 =
* Added: Improved handling of Send Email action CC / BCC filters

= 1.9.130 - 06/13/2023 =
* Bug Fix: Removed use of :is pseudo element in hidden field handler

= 1.9.129 - 06/13/2023 =
* Bug Fix: Fixed regex example for Phone - General
* Bug Fix: Fixed required field management for conversational forms

= 1.9.128 - 06/10/2023 =
* Added: Additional Send Email action hooks for BCC, CC and Reply To settings
* Bug Fix: Conditional logic initial firing on duplicate elements

= 1.9.127 - 06/06/2023 =
* Bug Fix: Fixed JavaScript issue with form selector on submissions page

= 1.9.126 - 06/05/2023 =
* Added: Tab active / not active conditional logic
* Bug Fix: Output buffer clear fix

= 1.9.125 - 06/01/2023 =
* Added: Improved population of ACF number fields
* Bug Fix: Ensured variable escaping is not considered translatable throughout

= 1.9.124 - 05/29/2023 =
* Added: #number_format(number, decimals, decimal_separator, thousands_separator) variable
* Added: #field_date_Format(field_id, date_format) variable

= 1.9.123 - 05/28/2023 =
* Added: Support for pushing select, checkbox and radio values to Pods text fields
* Bug Fix: File upload handler setting featured image on posts if using default file upload type

= 1.9.122 - 05/26/2023 =
* Added: Required setting on price fields
* Added: Price fields converted to float prior to being pushed to ACF number fields

= 1.9.121 - 05/25/2023 =
* Added: Required indicator added to checkbox label if 'Minimum Checked' setting is set
* Added: Added additional field types that can be mapped to Google Address fields
* Added: Override CSS to overcome styling issues found with poorly targeted CSS from third party plugins
* Changed: Removed single pixel GIF that was used to overcome an old formatting issue with Mac mail

= 1.9.120 - 05/24/2023 =
* Added: Improved saved data format for ACF mappings

= 1.9.119 - 05/23/2023 =
* Bug Fix: Review admin message

= 1.9.118 - 05/22/2023 =
* Added: Support for additional classes on block
* Added: Ability to specify custom title, caption, description and alt tag on media library uploads
* Added: Translation improvements
* Changed: Block preview now changed to GIF as opposed to SVG to avoid CSS issues with preview being in iframe
* Changed: Captcha fields can no longer be bypassed if they are hidden to improve security
* Bug Fix: Progress on repeaters
* Bug Fix: Mobile breakpoint font size in email template
* Bug Fix: Down arrow on select fields no longer obscured by long option text

= 1.9.117 - 05/18/2023 =
* Added: Accessibility improvements for honeypot field
* Added: Accessibility improvements for help text
* Added: Repeatable section row delete confirmation setting
* Added: Translated month and day names during date validation to support other languages
* Bug Fix: Conditional logic initial firing on repeatable section row adding

= 1.9.116 - 05/13/2023 =
* Added: Multiple row selection in conditional logic for row visibility, required, disabled, class
* Bug Fix: Image / file custom field integration issue with existing attachments

= 1.9.115 - 05/13/2023 =
* Bug Fix: #calc initial value was causing issues with HTML fields

= 1.9.114 - 05/11/2023 =
* Added: Multiple row selection in conditional logic for row select/check
* Added: Support for Google Routing in repeatable sections
* Bug Fix: #field delimiter parameter was trimmed

= 1.9.113 - 05/09/2023 =
* Changed: Quantity min / max bound checking now only occurs on field change

= 1.9.112 - 05/08/2023 =
* Bug Fix: WS Form (Private) file handler in repeatable sections
* Bug Fix: PDF image width in custom templates

= 1.9.111 - 05/05/2023 =
* Added: Removed invalid event handler inputmask fields to fix blur issue if setCustomValidity applied to it

= 1.9.110 - 05/04/2023 =
* Added: CSS max height in email template for signature field to avoid large images showing
* Changed: Webhook no longer halts action processing if node not found in response data
* Bug Fix: Custom validity recall issue if set in conditional logic and field then hidden

= 1.9.109 - 05/03/2023 =
* Bug Fix: #calc price value

= 1.9.108 - 05/02/2023 =
* Added: Input mask validation

= 1.9.107 - 05/01/2023 =
* Added: zxcvbn no longer enqueued if not required by password field
* Added: Improved handling of UTC date for 'Current Day' deduplication setting
* Bug Fix: Uncompiled non-inline API CSS path

= 1.9.106 - 04/25/2023 =
* Added: Flush on output if zip or file downloaded to overcome issues with rogue character in output buffer
* Added: Admin sidebar changes to prevent issues with poorly enqueued jQuery from third party plugins
* Bug Fix: Admin sidebar would not open if form text editor or HTML field contained wsf-field-wrapper class
* Bug Fix: #calc issue with calc object registering incorrect source field ID

= 1.9.105 - 04/24/2023 =
* Added: Support for JetEngine checkbox 'Save as Array' setting
* Bug Fix: #calc support in #field_date_offset

= 1.9.104 - 04/22/2023 =
* Added: Elementor widget updates

= 1.9.103 - 04/21/2023 =
* Added: Performance improvements for #calc / #text

= 1.9.102 - 04/21/2023 =
* Added: Support for JetEngine 'Is Timestamp' setting on date fields
* Bug Fix: Email validation

= 1.9.101 - 04/18/2023 =
* Added: Improved data source error handling and scheduling
* Added: Overrides for latest WordPress block editor CSS

= 1.9.100 - 04/17/2023 =
* Added: 'Importing ...' notice added to import progress bar
* Bug Fix: Calculation triggering on hidden fields

= 1.9.99 - 04/17/2023 =
* Added: Edit in Preview now supports file upload edits
* Added: Improved performance on file upload previews

= 1.9.98 - 04/16/2023 =
* Bug Fix: Dynamic #text label and help text on fields that did not allow dynamic #text on value
* Bug Fix: Statistics divide by zero issue

= 1.9.97 - 04/14/2023 =
* Added: Google Routing field. Provides distance and duration calculations between a start and end location. Learn more: https://wsform.com/knowledgebase/google-routing/
* Added: Google Maps template category
* Added: Google Routing templates
* Added: Mapping category in toolbox fields sidebar

= 1.9.96 - 04/12/2023 =
* Added: Support for plain permalink URL structure
* Added: Improved #email_logo handling to avoid bugs caused by third party software
* Bug Fix: #text with color fields now sets color panel preview

= 1.9.95 - 04/10/2023 =
* Bug Fix: Reports scheduling when upgrading from LITE to PRO

= 1.9.94 - 04/10/2023 =
* Added: Type selector for WebHook field and custom mapping

= 1.9.93 - 04/07/2023 =
* Bug Fix Checkbox and radio deduplication in repeatable sections

= 1.9.92 - 04/06/2023 =
* Added: Additional checks to ensure data passed to remote requests is valid
* Added: Support for roles that do not have capabilities assigned to them
* Bug Fix: Conditions no longer assesssed if source event is outside of repeatable section and IF condition contains fields in a repeatable section

= 1.9.91 - 04/05/2023 =
* Bug Fix: Dashboard date range fix

= 1.9.90 - 04/04/2023 =
* Added: WS Form --> Settings --> Reports setting allows for daily, weekly or monthly form statistics report sent via email
* Added: 'Show File Name and Size' setting under WS Form --> Settings --> Variables which removes file name and size under files and signatures in email and PDF templates
* Added: Signatures now recalled in saved forms
* Added: Date/time picker now has setting for moving the element within the form to avoid issues with parent elements having position: relative
* Changed: Signature cropping now moved server-side (Requires Imagick)
* Changed: WS Form --> Settings --> Email is now Variables
* Bug Fix: Patch implemented to overcome Safari issue with times

= 1.9.89 - 04/03/2023 =
* Added: Moved date/time picker element within form instead of within body to allow styling by form
* Added: Added ID to each date/time picker element
* Added: Custom class setting for date/time picker element

= 1.9.88 - 03/31/2023 =
* Added: Performance improvements to select, checkbox and radio fields (empty row attributes removed)
* Added: Performance improvements to repeatable section initialization
* Added: Performance improvements to form validation
* Added: Functionality for new PDF add-on variables #pdf_url and #pdf_link
* Bug Fix: WS Form framework was not being used in block editor for layout CSS if using Bootstrap
* Bug Fix: Section ID repair in imported meta data

= 1.9.87 - 03/29/2023 =
* Added: WordPress 6.2 compatibility testing
* Added: Requirements added to main PHP file
* Bug Fix: Capitalize transform feature was not working for some european characters

= 1.9.86 - 03/29/2023 =
* Changed: Simplified Human Presence functionality to rely on its own confidence level

= 1.9.85 - 03/28/2023 =
* Bug Fix: Layout editor no longer saves if sidebar is locked (e.g. requesting data from an API)

= 1.9.84 - 03/26/2023 =
* Added: Update ready for Breakdance v1.3
* Added: Check on SVG creation to ensure form object is valid

= 1.9.83 - 03/23/2023 =
* Bug Fix: JetEngine media and gallery field population

= 1.9.82 - 03/23/2023 =
* Added: Improved button locking functionality
* Added: Improved form checksum validation on import
* Bug Fix: Media library meta data when custom file name specified
* Bug Fix: Webhook encoding of values containing arrays

= 1.9.81 - 03/18/2023 =
* Added: Patch to ensure adding parameters to API URL using add_query_arg does not convert periods to underscores

= 1.9.80 - 03/18/2023 =
* Bug Fix: API call fix for AWeber

= 1.9.79 - 03/17/2023 =
* Added: Spam level indicators added to LITE edition
* Added: Additional admin CSS fixes for third party plugin that incorrectly enqueued Bootstrap on every page
* Bug Fix: Submission records were still created if Human Presence detected spam

= 1.9.78 - 03/15/2023 =
* Added: PDF previews on DropzoneJS file uploads
* Added: Ability to preview / download DropzoneJS file uploads in submissions when form saved
* Added: Admin CSS fixes for third party plugin that incorrectly enqueued Bootstrap on every page

= 1.9.77 - 03/10/2023 =
* Bug Fix: db_get_submit_meta duplicating values if run via WooCommerce extension

= 1.9.76 - 03/09/2023 =
* Added: Webhook API response mapping now supports array in JSON response
* Added: Webhook now has improved handling of query variables in GET requests

= 1.9.75 - 03/08/2023 =
* Added: Improved Google Events functionality https://wsform.com/knowledgebase/google-events/
* Added: Improved handling of repeatable fallback values on submissions page 

= 1.9.74 - 03/06/2023 =
* Bug Fix: Label positioning adjustment on phone fields

= 1.9.73 - 03/02/2023 =
* Added: Support for glossaries in JetEngine Field Options data source
* Added: Set minimum/maximum date and time conditional logic for date/time field type
* Added: Enabled times feature on date/time field type
* Added: Separated min/max time setting on date/time field configured as type 'Date/time' or 'Time'
* Added: Field match conditional logic support for values inside a repeater
* Bug Fix: CSS fix for Phone field configured to use inside label with international telephone input enabled

= 1.9.72 - 02/28/2023 =
* Added: Context to JetEngine get field settings method to support user fields

= 1.9.71 - 02/27/2023 =
* Added: Set title of email template to email subject
* Added: Default file type set to DropzoneJS on file upload fields
* Bug Fix: Custom file name on media library files

= 1.9.70 - 02/22/2023 =
* Added: Patch to overcome older browsers not supporting date formats in Y-m-d H:i:s format

= 1.9.69 - 02/21/2023 =
* Added: Form validation when required status of field changes
* Bug Fix: Redirect action URL parsing

= 1.9.68 - 02/17/2023 =
* Added: Additional functionality for PDF add-on

= 1.9.67 - 02/15/2023 =
* Bug Fix: ITI (International Telephone Input) for multiple form instances on a single page

= 1.9.66 - 02/14/2023 =
* Added: Ability to assign multiple values to a single key in Webhook (converted to array with dedupe setting)
* Added: wsf_dropzonejs_upload_path filter for DropzoneJS upload path
* Added: Dependencies for DropzoneJS enqueue

= 1.9.65 - 02/07/2023 =
* Added: Improved rendering of conditional logic in admin sidebar
* Added: Support for population of hidden fields for Google Address field
* Added: Edit in Preview link on submissions (Must be enabled in settings)

= 1.9.64 - 02/06/2023 =
* Added: Meta Box custom table support
* Bug Fix: Changing a hidden required field to no required was reverted to required with made visible
* Bug Fix: Dashboard component registration if user capability not set

= 1.9.63 - 02/05/2023 =
* Added: Event resetting on form reload
* Bug Fix: #calc / #text now processes original source instead of parsed source 
* Bug Fix: Conditional logic on conversational forms

= 1.9.62 - 02/03/2023 =
* Added: Patch to overcome known bug with :valid / :invalid selectors in certain browsers

= 1.9.61 - 02/03/2023 =
* Added: Support for population of select fields configured with Select2 + AJAX
* Added: Custom attributes for divider field type
* Bug Fix: Field class setting for divider field type

= 1.9.60 - 02/02/2023 =
* Bug Fix: Setting values in textarea fields using TinyMCE

= 1.9.59 - 02/02/2023 =
* Bug Fix: WooCommerce extension file upload field processing
* Bug Fix: Sidebar select2 caching issue

= 1.9.58 - 02/01/2023 =
* Bug Fix: Setting price values with conditional logic or Webhook return

= 1.9.57 - 01/30/2023 =
* Bug Fix: reCAPTCHA V3 timeout issue

= 1.9.56 - 01/29/2023 =
* Bug Fix: Setting values on hidden fields with conditional logic or Webhook return

= 1.9.55 - 01/28/2023 =
* Added: Saved File Name setting for file uploads to allow for custom file names

= 1.9.54 - 01/27/2023 =
* Bug Fix: Setting label on button configured as submit using conditional logic

= 1.9.53 - 01/26/2023 =
* Added: Forced 200 HTTP response if API requests successful (third parties were changing this in hook)
* Added: Firefox JS number rounding bug patch (their number field is limited to 14 decimal places if certain languages are set)
* Added: Change to node value set function for Webhook function to avoid error if node key used twice in mappings
* Bug Fix: Sidebar select2 initialization issue

= 1.9.52 - 01/25/2023 =
* Added: Improved CSS escaping for skin output
* Bug Fix: Conversational progress bar

= 1.9.51 - 01/25/2023 =
* Bug Fix: Tab validation showing validation errors was not working with Bootstrap framework
* Bug Fix: get_user_id function

= 1.9.50 - 01/24/2023 =
* Changed: Push to Custom Endpoint renamed to Webhook
* Added: Return field mapping functionality on Webhook action allows return from API requests to populate form fields
* Added: Support for dot notation in Webhook field, custom and return mapping (e.g. result[0].name.first)
* Added: SSL Verify, Timeout and Cookie Passthrough options to Webhook
* Added: Webhook Return Mapping demo template
* Added: Change event to Hidden field conditional logic
* Bug Fix: Select2 AJAX results conditional logic no longer fires on form render

= 1.9.49 - 01/23/2023 =
* Bug Fix: Next tab button disabling using prop method

= 1.9.48 - 01/22/2023 =
* Added: JetEngine integration support for Post Management (1.5.0) add-on
* Added: JetEngine integration support for User Management (1.5.0) add-on
* Added: JetEngine field option data source
* Added: Select2 custom message settings
* Added: Select2 AJAX results conditional logic
* Added: Improved custom action detection

= 1.9.47 - 01/19/2023 =
* Bug Fix: wpautop on text/plain content type emails

= 1.9.46 - 01/19/2023 =
* Added: Additional parameters added to cookies when set 'SameSite=Strict; Secure'
* Bug Fix: ACF button group saving

= 1.9.45 - 01/18/2023 =
* Bug Fix: Button disabling with WooCommerce extension

= 1.9.44 - 01/17/2023 =
* Added: ip-api as a geolocation service
* Added: geoPlugin / ip-api API key settings for commercial versions of geolocation services
* Added: Improved geolocation request headers to avoid invalid usage messages
* Added: Google Address component mapping options added for Street full - Short/Long (Reverse order)
* Bug Fix: Submission not assessing available fields correctly when layout only fields or user role restrictions imposed

= 1.9.43 - 01/16/2023 =
* Added: Updated Elementor widget registration code for version 3.5+
* Added: Updated PHP sort functions

= 1.9.42 - 01/15/2023 =
* Added: Meta value sorting option for posts data source

= 1.9.41 - 01/13/2023 =
* Added: New support functions for OpenAI add-on

= 1.9.40 - 01/09/2023 =
* Bug Fix: Deduplication using 'Current Day' method

= 1.9.39 - 01/09/2023 =
* Added: Do not apply wpautop functionality to client side #field use
* Added: Ability to use HTML in #field delimiter

= 1.9.38 - 01/08/2023 =
* Changed: Removed fitBounds event when Google Map search place is clicked on to stop zoom irregularities

= 1.9.37 - 12/31/2022 =
* Bug Fix: International telephone input threw error if form submitted too quickly (e.g. with conditional logic)

= 1.9.36 - 12/28/2022 =
* Added: Improved mark-up in email templates

= 1.9.35 - 12/25/2022 =
* Bug Fix: wpautop on submissions page

= 1.9.34 - 12/21/2022 =
* Added: Server side validation now applies to all mappable fields
* Changed: wpautop is now applied to Text Area fields configured as 'Default' when output in actions (e.g. Emails). #wpautop is no longer required to format this content. A 'Do Not Apply wpautop' setting is also available under 'Advanced' for Text Area fields if you want to revert to an unformatted output.

= 1.9.33 - 12/16/2022 =
* Added: Performance improvement on form submit

= 1.9.32 - 12/13/2022 =
* Added: Sidebar lock when retrieving integration data
* Bug Fix: CodeMirror mode for JavaScript editors

= 1.9.31 - 12/09/2022 =
* Added: Global setting for reCAPTCHA, hCaptcha and Turnstile keys

= 1.9.30 - 12/05/2022 =
* Bug Fix: Captcha silent validation

= 1.9.29 - 12/02/2022 =
* Added: Further improvements to license management

= 1.9.28 - 12/01/2022 =
* Added: Improved licensing management to avoid license deactivation on DB locks

= 1.9.27 - 11/30/2022 =
* Bug Fix: Tag labels when creating form from action template

= 1.9.26 - 11/29/2022 =
* Added: Improved honeypot field for accessibility
* Bug Fix: Logging error in LITE edition for captcha fields

= 1.9.25 - 11/25/2022 =
* Added: Performance improvement on client side. Custom field configuration no longer loading in data sources.
* Added: Support for serialized data in submissions page when added to hidden field meta data

= 1.9.24 - 11/18/2022 =
* Added: Support for WooCommerce booking plugin

= 1.9.23 - 11/16/2022 =
* Added: Validate number setting under international telephone input setting on phone field
* Added: #session_storage_get(key) variable
* Added: #local_storage_get(key) variable
* Added: Placeholder setting to date / time field

= 1.9.22 - 11/15/2022 =
* Bug Fix: Form validation on Select2 + AJAX pre-populated fields

= 1.9.21 - 11/15/2022 =
* Added: Support for Meta Box relationship fields
* Bug Fix: Field / tab focus on form submit

= 1.9.20 - 11/12/2022 =
* Added: Ability to use min/max with repeatable #field(123) input
* Changed: Progress bar CSS to ensure right border radius appears at 100%

= 1.9.19 - 11/10/2022 =
* Change: Duration cookie removed in LITE edition
* Bug Fix: Next tab validation to show invalid feedback if tabs were hidden

= 1.9.18 - 11/09/2022 =
* Added: Support for dynamic enqueuing on payment forms that don't include e-commerce fields

= 1.9.17 - 11/09/2022 =
* Bug Fix: wsf_field_row_add function fixed

= 1.9.16 - 11/07/2022 =
* Added: Breakdance website builder element
* Added: Ability to use variables in the custom endpoint action URL
* Bug Fix: Field step bypass on hidden fields 

= 1.9.15 - 11/02/2022 =
* Bug Fix: Data format fix for Meta Box select fields without multiple setting enabled

= 1.9.14 - 10/30/2022 =
* Added: Support for WooCommerce geolocalize users with cache
* Added: wsf_form_get_count_submit function for returning total public form submissions by form ID

= 1.9.13 - 10/29/2022 =
* Added: Support for quantity values being populated using different decimal separators
* Bug Fix: Quantity field with decimals when using character other than period for decimal separator

= 1.9.12 - 10/27/2022 =
* Changed: Database primary key and relational field types changed to match WordPress
* Bug Fix: Show dynamic enqueuing setting for all frameworks

= 1.9.11 - 10/26/2022 =
* Added: Honeypot SEO improvement
* Bug Fix: Submissions read/unread display
* Bug Fix: wpautop JavaScript function

= 1.9.10 - 10/22/2022 =
* Bug Fix: Conditional logic for setting repeatable section rows

= 1.9.9 - 10/22/2022 =
* Added: wsf_form_get_fields_by_label function
* Bug Fix: JavaScript action registration

= 1.9.8 - 10/21/2022 =
* Added: unfiltered_html capability extended to data grids

= 1.9.7 - 10/20/2022 =
* Added: Compliance with the unfiltered_html capability which prevents saving of unfiltered HTML on all object data (https://wsform.com/knowledgebase/preventing-users-from-saving-markup-in-the-layout-editor/)
* Bug Fix: Default button colors
* Bug Fix: Cascade dynamic enqueuing

= 1.9.6 - 10/19/2022 =
* Added: Reviewed wpdb functionality throughout
* Added: Improved DropzoneJS error handling
* Added: Form and submit objects to email filters
* Bug Fix: Submission export animated gif

= 1.9.5 - 10/18/2022 =
* Added: Support for performance plugins with dynamic enqueue
* Changed: Removed WP_List_Table class to rely on class included with WordPress core
* Bug Fix: Password confirmation conditional logic if password strength invalid feedback enabled

= 1.9.4 - 10/17/2022 =
* Bug Fix: GeoIP lookup endpoint
* Bug Fix: Tab indexing on refresh

= 1.9.3 - 10/17/2022 =
* Bug Fix: Date variables without date fields

= 1.9.2 - 10/17/2022 =
* Added: #field with delimiter support for price select, price checkbox and price radio fields
* Added: Quality and price total auto map on clone
* Bug Fix: Tab indexing on clone

= 1.9.1 - 10/16/2022 =
* Added: Reviewed santitization, escaping and validation throughout
* Added: Improved code to make security reviews easier in future

= 1.9.0 - 10/14/2022 =
* Added: Dynamic enqueuing setting (Global settings)
* Added: Public JS optimized throughout to dramatically reduce file download size
* Added: Minimum password strength setting on password field
* Added: Suggest password setting on password field
* Added: Generate password option in conditional logic for password fields
* Bug Fix: Population of price checkbox fields

= 1.8.236 - 10/11/2022 =
* Added: Bricks element dynamic form ID setting

= 1.8.235 - 10/09/2022 =
* Added: Remove Arrows/Spinners option for number and quantity fields
* Bug Fix: Input mask component incorrectly setting decimal point if decimal places set to 0

= 1.8.234 = 10/07/2022 =
* Added: Page and Post ID options added to redirect action
* Added: Error handling improvements for captcha server-side validation
* Added: Conditional logic assessed when field set validation occurs
* Bug Fix: International Telephone Input initialization height

= 1.8.233 - 10/06/2022 =
* Added: Show invalid fields option for tab validation
* Added: wsf_submit_field_validate filtered by submit_save setting
* Added: Date validation support for min / max when set to EPOCH format, e.g. +1970-01-05
* Changed: wsf_form_get_form_label function now usable when not logged in as admin
* Bug Fix: Checkbox / Select field max setting was not assessed if invalid feedback was disable
* Bug Fix: Date population if min / max contained EPOCH format or variables

= 1.8.232 - 10/05/2022 =
* Bug Fix: Post Status data source column headings

= 1.8.231 - 10/04/2022 =
* Added: Cloudflare Turnstile captcha widget
* Added: Translatable 'week' in date/time field
* Added: Performance improvement on custom field date calculations
* Bug Fix: #calc using European price formats

= 1.8.230 - 10/04/2022 =
* Bug Fix: Meta box date processing for international formats

= 1.8.229 - 10/03/2022 =
* Added: Auto-focus on Select2 search when Select2 is opened
* Bug Fix: Placeholder on select field with cascading required data-placeholder attribute

* 1.8.228 - 10/01/2022 =
* Added: Note field type for adding notes in the layout editor
* Added: Cloud file handler settings added to signature field
* Added: Conditional logic select all / deselect all for select and checkbox fields
* Added: Spam Protection field group
* Added: Meta Box date field Timestamp / Save Format support
* Changed: Basic mode no longer renders different field types in admin sidebar settings

= 1.8.227 - 09/27/2022 =
* Added: Query string parameter setting in redirect action

= 1.8.226 - 09/26/2022 =
* Added: Ability to edit fields using data sources in submissions page
* Bug Fix: Form SVG generator for buttons and messages set to type none

= 1.8.225 - 09/21/2022 =
* Added: cookie_get("name") variable

= 1.8.224 - 09/18/2022 =
* Bug Fix: Left alignment on inside label if prefix is applied to a field

= 1.8.223 - 09/17/2022 =
* Added: Upgraded input-mask library to version 5.0.7 to fix JS error in Oxygen when editing a product template
* Changed: German translations improved with thanks to @maexx for his contribution
* Bug Fix: User management add-on threw an error when listing fields if an add-on was not configured
* Bug Fix: CSS class error when unable to write cached files in uploads folder

= 1.8.222 - 08/29/2022 =
* Added: #checkbox_count(id) variable. This returns the number of checkboxes checked on a checkbox field.
* Added: #select_count(id) variable. This returns the number of options selected on a select field.
* Added: Support for calculations with currencies that have blank decimal or thousand separators.
* Added: Error thrown if negative value occurs in cart detail fields without 'Allow Negative Value' checked.

= 1.8.221 - 08/24/2022 =
* Added: Performance improvement: wp_options data for CSS cache now split into separate record
* Added: Performance improvement: wp_options data now has autoload set to 'no'
* Added: Business related field mappings for Google Address field
* Added: Rows setting for text area configured to use Visual Editor
* Bug Fix: Removed duplicate field class on radio field group wrapper
* Bug Fix: Case sensitive issue with select field value checking in conditional logic

= 1.8.220 - 08/11/2022 =
* Added: Bi-directional population for all Meta Box file and image field types
* Added: 'Show All If No Results' setting in Search fields under Select2 --> AJAX
* Added: Population of select fields if using Select2 --> AJAX
* Bug Fix: Canonical URL fixed on conversation form pages

= 1.8.219 - 08/10/2022 =
* Added: Bricks Builder 1.4 / 1.5 support
* Bug Fix: Conditional logic now checks if field exists in DOM when checking values
* Bug Fix: Cached RTL skin and layout CSS was not loading if not rendered inline

= 1.8.218 - 08/07/2022 =
* Added: Support for #field column look ups for term, post and user data sources

= 1.8.217 - 08/06/2022 =
* Added: #trim variable
* Bug Fix: Corrected Meta Box data format for singular checkbox / select choices

= 1.8.216 - 08/05/2022 =
* Added: #post_status variable
* Bug Fix: get_number function with currency symbols containing the decimal separator character

= 1.8.215 - 07/26/2022 =
* Added: Improved support for Fancybox when form contains Visual Editor (TinyMCE)

= 1.8.214 - 07/19/2022 =
* Added: Additional date format support for submission date range searching

= 1.8.213 - 07/18/2022 =
* Added: #request_url variable that returns the page URL you are on, regardless of the template
* Changed: Form lists order changed to order by name and then ID
* Bug Fix: Submissions date range searching
* Bug Fix: 'Selected value does not equal' was not appearing in conditional logic options for select fields

= 1.8.212 - 07/07/2022 =
* Added: $form_object attribute set on 'Get Data' for WordPress Hook data source
* Bug Fix: Disabled add view REST API requests in LITE edition
* Bug Fix: Vertical tab alignment on WooCommerce products

= 1.8.211 - 06/29/2022 =
* Added: Support for terms and term categories without labels
* Added: EDD licensing improvements
* Changed: Bricks element label changed to 'WS Form'

= 1.8.210 - 06/20/2022 =
* Added: Google Address component mapping now supports 'subpremise' (Used for unit # in Australia)

= 1.8.209 - 06/08/2022 =
* Added: Google Address result type options (All, Address, Businesses, Cities, Regions)

= 1.8.208 - 05/31/2022 =
* Added: Server-side limit checks on form submit
* Bug Fix: Run WordPress Hook message form scrolling configuration

= 1.8.207 - 05/27/2022 =
* Added: Required setting added to legal fields (User must scroll through entirety of legal text to validate field)

= 1.8.206 - 05/20/2022 =
* Bug Fix: Title attribute on spam indicator on submissions page

= 1.8.205 - 05/18/2022 =
* Added: Inline validation setting on fields and sections
* Added: Neighborhood and Formatted Address mapping to Google Address field
* Added: Formatted Address added to data transfer from Google Address to Google Map field
* Added: Additional admin CSS to override poorly targetted CSS from third party plugins
* Changed: Improved German translations (Thanks to @upt2 for their contribution)

= 1.8.204 - 05/14/2022 =
* Bug Fix: Cached CSS file build for fresh install on admin side

= 1.8.203 - 05/13/2022 =
* Changed: Gravity Forms migration updates
* Bug Fix: WordPress hook data source row ID across separate groups

= 1.8.202 - 05/12/2022 =
* Added: Ability to run server-side validation on form save

= 1.8.201 - 05/09/2022 =
* Added: After form lock, only buttons that were originally enabled are re-enabled

= 1.8.200 - 05/06/2022 =
* Added: Support for WPForms LITE migration with no submission data

= 1.8.199 - 05/03/2022 =
* Bug Fix: Server-side #blog_date_custom variable fix

= 1.8.198 - 05/02/2022 =
* Added: Support for select2 in Elementor pop-ups
* Added: #submit_url_hash variable which returns only the hash query variable part

= 1.8.197 - 04/26/2022 =
* Bug Fix: Blur / focus conditional logic events

= 1.8.196 - 04/25/2022 =
* Added: Improved behavior of marker on Google Maps. Drag and drop. No re-centering on map click.
* Changed: Updated Elementor widget to support latest class structure

= 1.8.195 - 04/18/2022 =
* Added: Support for #calc sums using #field with a column specified

= 1.8.194 - 04/12/2022 =
* Added: Revised date formats passed to JS Date function to overcome Safari bug
* Bug Fix: Stop compiled CSS files being enqueued in admin for visual builders

= 1.8.193 - 04/04/2022 =
* Bug Fix: Meta box taxonomy population for multiple values

= 1.8.192 - 03/29/2022 =
* Bug Fix: Conditional logic action enable / disable was not resetting on subsequent form submissions

= 1.8.191 - 03/25/2022 =
* Bug Fix: Fixed default data grid columns for field generated for Meta Box that utilize a data source

= 1.8.190 - 03/23/2022 =
* Changed: Removed color reference on 'Add-Ons' and 'Upgrade' menu items to better support admin themes
* Changed: Removed need for spacer image in standard HTML email template

= 1.8.189 - 03/14/2022 =
* Added: Support for #field with column attribute for values containing row parse values

= 1.8.188 - 03/09/2022 =
* Added: PATCH to Push to Custom endpoint action
* Bug Fix: Min / max on date / time field configured as type 'Time'
* Bug Fix: Column hiding on forms admin page

= 1.8.187 - 02/22/2022 =
* Added: reCAPTCHA V3 reset on form submit
* Added: Encoding of analytics functions to avoid conflicts with plugins containing poor regex functions intended for identifying cookie / analytics scripts
* Bug Fix: Server side column mapping with data grid parse variables

= 1.8.186 - 02/17/2022 =
* Bug Fix: #field iterator checking

= 1.8.185 - 02/15/2022 =
* Bug Fix: Trim and validity checking on multi parameter variables

= 1.8.184 - 02/13/2022 =
* Added: delimiter and column parameters added to #field variable for data grids. #field(id, delimiter, column). Column can be the column label or index (0 is first column)
* Added: Donation amount template added to section library

= 1.8.183 - 02/10/2022 =
* Added: Improved targeting of jQuery sortable 1.13.1 script override

= 1.8.182 - 02/07/2022 =
* Bug Fix: ACF date field population if value is empty

= 1.8.181 - 02/06/2022 =
* Added: Clear session hash with Conditional Logic (Form --> Clear session hash)
* Bug Fix: Typing enter in post editor label field cause Add Form modal to open. Not a WS Form bug but workaround implemented.
* Bug Fix: Media library was not opening with recent jQuery UI sortable fix.

= 1.8.180 - 02/01/2022 =
* Added: form_id and field_id parameters added to wsf_action_email_email_validate hook

= 1.8.179 - 02/01/2022 =
* Added: WooCommerce: Ability to save form as well as save & continue
* Added: WooCommerce: Form hash cleared when product added to cart
* Added: WooCommerce: Ability to run actions using conditional logic
* Added: Support for shortcodes in email templates (Shortcodes cannot be entered into fields for security reasons)
* Added: Ability to search for submissions by date range using site date format (Now supports d/m/Y)
* Added: New action: wsf_enqueue_public (Runs if WS Form enqueues have occurred)
* Added: Media library files embedded using URL instead of Base64 encoding for improved email support
* Bug Fix: Google event firing was occurring if parent checkbox was disabled.

= 1.8.178 - 02/01/2022 =
* Added: Placeholder on Google Address field
* Bug Fix: Conditional value setting with URL type fields

= 1.8.177 - 01/30/2022 =
* Added: Improved key obscuring in settings
* Added: Improved CSS / font loading for compatibility with WordPress.com
* Bug Fix: Submission read by hash now excludes trashed records

= 1.8.176 - 01/26/2022 =
* Added: Translatable string improvements throughout
* Bug Fix: XSS fix: Admin label encoding in form list
* Bug Fix: XSS fix: Text extraction from text area fields in submission viewer

= 1.8.175 - 01/26/2022 =
* Bug Fix: LiteSpeed fix

= 1.8.174 - 01/26/2022 =
* Added: #wpautop(string) variable

= 1.8.173 - 01/26/2022 =
* Bug Fix: Hidden static fields were not excluded from #email_submission variable

= 1.8.172 - 01/24/2022 =
* Added: wsf_tab_index_<form_id> query variable that allows linking directly to tabs on forms
* Added: Close icon on debug console (Debug console can be re-opened in Global Settings --> Advanced)
* Added: Debug console now remembers height when minimized or restored if page refreshed

= 1.8.171 - 01/22/2022 =
* Added: wsf_submit_meta_read($meta_value, $field_id) and wsf_submit_meta_update($meta_value, $field_id) filter hooks

= 1.8.170 - 01/22/2022 =
* Added: Virtual keyboard disable option for date / time fields (Improves usability of date / time picker on mobile)
* Added: Virtual keyboard setting for text and text area fields
* Added: Improved license and key obscuring for all add-ons

= 1.8.169 - 01/21/2022 =
* Bug Fix: Conditional logic applying values to hidden fields in repeatable sections

= 1.8.168 - 01/19/2022 =
* Added: Submissions export support for sites with permalinks configured as plain
* Bug Fix: Tab navigation if tabs hidden

= 1.8.167 - 01/19/2022 =
* Bug Fix: ACF population of values containing amphersand
* Bug Fix: ACF true/false field type value now set to 0 or 1

= 1.8.166 - 01/17/2022 =
* Added: Tranform setting on text based fields: Uppercase, Lowercase, Capitalize, Sentence
* Added: Variables: #upper(string), #lower(string), #ucfirst(string), #ucwords(string), #capitalize(string), #sentence(string)
* Bug Fix: Tab navigation if first tab hidden

= 1.8.165 - 01/16/2022 =
* Added: ARIA attributes added to progress field
* Bug Fix: aria-disabled attribute on repeatable section navigation

= 1.8.164 - 01/16/2022 =
* Added: Block pattern library
* Bug Fix: Tab rendering if first tab hidden

= 1.8.163 - 01/14/2022 =
* Added: Sidebar changes now auto save if you switch to a different sidebar, tab, section or field
* Added: Updated version numbers on external enqueues
* Added: Submission form selector now shows '0 records' instead of disabling the option

= 1.8.162 - 01/07/2022 =
* Bug Fix: Conversational field change events limited to current section to avoid form jumping if dynamic field changes in non-focussed sections occur

= 1.8.161 - 01/06/2022 =
* Added: Improved accessibility for repeatable section icons
* Added: WordPress 5.9 uses jQuery UI 1.13.0 which has a positioning bug when dragging fields to the form (https://github.com/jquery/jquery-ui/issues/2001). Version 1.12.1 of jQuery UI sortable is now bundled with WS Form to overcome this issue.

= 1.8.160 =
* Added: DropzoneJS thumbnail image size filter hook: wsf_dropzonejs_image_size($size). $size must exist in get_intermediate_image_sizes()
* Added: Improved language on welcome screen framework selection step
* Bug Fix: Conversational next field focussing

= 1.8.159 =
* Bug Fix: Color function for PHP 8.1

= 1.8.158 =
* Added: WordPress 5.9 / PHP 8.1 compatibility preparation
* Bug Fix: Conditional logic data grid column mapping

= 1.8.157 =
* Added: New 'Run WordPress Hook' filter returns can now trigger form errors. See: https://wsform.com/knowledgebase/run-wordpress-hook/
* Added: Additional no cache headers and Litespeed no cache directives for save, submit requests

= 1.8.156 =
* Bug Fix: Date >=, <= comparisons in conditional logic with EU date formats

= 1.8.155 =
* Added: Google Address map assignment initial zoom setting
* Added: Improvement to tab ARIA attributes

= 1.8.154 =
* Added: NONCEs on public forms where a user is not logged are now optional to allow for increased cache timeouts

= 1.8.153 =
* Added: Various accessibility improvements (ARIA tags and text contrast)
* Added: Improved min/max file size error messages
* Bug Fix: Repeater deduplication between fields

= 1.8.152 =
* Added: Improved reset and clear functionality for file fields

= 1.8.151 =
* Bug Fix: SVG URL encoding issue for select down arrows

= 1.8.150 =
* Added: Support for legacy WordPress date functions (WP < 5.3)
* Bug Fix: Conditional logic numeric checks fixed for EU number formats

= 1.8.149 =
* Bug Fix: Field change events now initialized before initial calculations fire

= 1.8.148 =
* Added: wp_mail errors now include PHPMailerPHPMailerException error message
* Added: Media (attachment) post type to Post data source. Added 'inherit' post status so that attachments can be listed.
* Added: Running the 'Save Submission' action via conditional logic now returns a submission hash
* Added: Improved translation strings. Moved translations out of constants.
* Added: Obscured license key in system report

= 1.8.147 =
* Added: Support for repeat label hiding on H1 - H6 as well as legend
* Added: Improved accessibility markup for repeatable section icons
* Bug Fix: Section delete variable clean up
* Bug Fix: Word and character count validation if help text empty

= 1.8.146 =
* Bug Fix: Database action auto archiving feature (cron action)

= 1.8.145 =
* Bug Fix: Welcome screen fixes for PC version of Chrome

= 1.8.144 =
* Bug Fix: Submission status filter links

= 1.8.143 =
* Bug Fix: Term lookup cache in post data source bug if term removed
* Bug Fix: WooCommerce price meta data now converted to floating point

= 1.8.142 =
* Bug Fix: Calculations from select fields were processed as currency
* Bug Fix: Rounding error in source field for calculations if commas used as decimal separator

= 1.8.141 =
* Bug Fix: Conversational URL link

= 1.8.140 =
* Added: Support for WooCommerce product meta data (Post management add-on)
* Bug Fix: Debug populate number fields with step of 'any'

= 1.8.139 =
* Added: New functionality ready for Amazon S3 integration for file fields
* Added: Form search
* Added: Third parameter to #field_date_offset variable to allow formatting of output
* Added: wsf_form_create_meta_data($meta_data) filter that allows meta data to be edited prior to form being created
* Added: Cost by area template

= 1.8.138 =
* Added: intl-tel-input support for phone field. https://intl-tel-input.com/. Check 'Enable' under 'International Telephone Input' in the basic tab to use it.

= 1.8.137 =
* Changed: Server and blog date formats with upgraded WordPress date/time methods

= 1.8.136 =
* Changed: Improved third party custom field plugin detection and add-on initialization

= 1.8.135 =
* Added: #field_date_offset(field_id, offset_in_seconds) variable. Returns a date field with an offset added or subtracted in seconds.
* Changed: Duration tracking is now switched off by default
* Bug Fix: PHP 8 fix in Divi module

= 1.8.134 =
* Bug Fix: Duration cookie no longer set if duration tracking disable

= 1.8.133 =
* Bug Fix: Table prefix on Post data source when retrieving terms

= 1.8.132 =
* Added: 'Use URLs for file fields' setting in 'Push to Custom Endpoint' action
* Added: reCaptcha V3 revisions
* Changed: Submission export temporary folder location

= 1.8.131 =
* Bug Fix: Double quote detection in variable attributes

= 1.8.130 =
* Added: New hCaptcha field
* Changed: Performance improvement on change triggering for cart detail fields

= 1.8.129 =
* Added: Migration from Gravity Forms 2.5 now supports column widths
* Added: Ability to use #field to fields outside a repeatable section in #section_rows_start ... end
* Bug Fix: Migrate tool submissions import meta data
* Bug Fix: Meta Box checkbox issue in repeaters

= 1.8.128 =
* Added: Form level Google Analytics events
* Added: gtm.formSubmit Google Tag Manager Form Submission trigger support
* Added: Change event fired when Google Address fields populated

= 1.8.127 =
* Added: Latitude and longitude mapping for the Google Address field
* Bug Fix: Parameter ordering issue for GA tracking objects

= 1.8.126 =
* Change: Improved detection of custom field plugins in multi-site environments
* Bug Fix: Google Analytics event tracking for ga contained in tag manager
* Bug Fix: Meta box repeater (group) fields not recognized in field mapping

= 1.8.125 =
* Added: New Google Address field allows you to auto populate address fields from a Google Places Autocomplete API search

= 1.8.124 =
* Added: Performance improvements with #calc and other price related calculations

= 1.8.123 =
* Added: New filter wsf_action_email_email_validate($valid, $email) added for filtering unwanted email addresses

= 1.8.122 =
* Added: Updated option checking in Meta Box and ACF classes
* Bug Fix: Dedupe value scope processing issue

= 1.8.121 =
* Added: Increased length of form, tab, section and field labels to 1024 characters
* Added: Improved database indexing

= 1.8.120 =
* Bug Fix: Tab validation misreported valid email address if field was not required

= 1.8.119 =
* Added: Toolset version check to ensure latest public functions are available

= 1.8.118 =
* Added: User ID set to current user ID when elements cloned in admin

= 1.8.117 =
* Added: Improved Elementor class declaration
* Added: Improved SVG background image encoding in skin CSS
* Bug Fix: HTML encoded labels for third party form selectors
* Bug Fix: File count conditional logic when using file fields in repeaters

= 1.8.116 =
* Bug Fix: WooCommerce class PHP 8 compatibility

= 1.8.115 =
* Added: Toolset integration support for Post Management (1.4.0) add-on
* Added: Toolset integration support for User Management (1.4.0) add-on
* Added: Toolset field option data source
* Bug Fix: Mouseover event on radio fields

= 1.8.114 =
* Added: Improved data sources so that column names retained but rows cleared on save

= 1.8.113 =
* Added: Ability to filter data source terms by those checked on a post

= 1.8.112 =
* Added: Support for conditional logic mouse events on select2 elements

= 1.8.111 =
* Added: Email field allow / deny values with wildcard (e.g. Allow *@wsform.com). Found in 'Advanced' tab.

= 1.8.110 =
* Added: Variable parsing on email header keys and values
* Bug Fix: Submission count recalculated when record status set to trash

= 1.8.109 =
* Added: Ability to use fields that return multiple values (e.g. checkboxes) as #field in email action 'To' setting
* Added: Ability to use variables with attributes embedded in #if statements
* Added: Improved z-indexing in admin
* Added: Improved time function handling per WordPress recommendations

= 1.8.108 =
* Added: Support for multiple textarea fields configured as type HTML
* Added: Reset data grids if a field is saved with a data source selected to minimize form data size
* Bug Fix: Cascade / AJAX select fields with no group data caused warning

= 1.8.107 =
* Added: URL element added to files in custom API endpoint action

= 1.8.106 =
* Bug Fix: Bulk Action Mark as Spam fixed

= 1.8.105 =
* Bug Fix: Encryption class includes for initial key generation

= 1.8.104 =
* Added: Conversion tracking now support variables
* Bug Fix: Improvement to encryption class includes
* Bug Fix: Elementor script and style enqueues

= 1.8.103 =
* Added: Ability to enable optgroup using the WordPress hook data source
* Added: CSS for tooltips in labels, e.g. <span data-wsf-tooltip="Tooltip">Icon</span>
* Added: Applied wpautop to message action content
* Added: Improved data picker styles
* Added: Booking template in section library
* Bug Fix: Password visibility toggle
* Bug Fix: Updated email regex pattern throughout to support new TLD's
* Bug Fix: Inline date picker

= 1.8.102 =
* Added: Post statuses data source
* Bug Fix: Lower track on range slider was not rendering if #value was missing from help setting

= 1.8.101 =
* Added: wsf_submit_clear_meta_filter_keys filter (Used for new feature in post management add-on version 1.3.2)
* Bug Fix: Taxonomy list in post data source

= 1.8.100 =
* Added: Support for hidden sections in conversational forms
* Bug Fix: Improved Meta Box field lookups to handle meta boxes assigned to more than one post type

= 1.8.99 =
* Added: Ability to self reference field when using #field in labels, placeholder and help
* Bug Fix: Bug fix on conditional logic setting value using #field in repeatable section

= 1.8.98 =
* Added: Performance improvement on clearing select fields with conditional logic
* Bug Fix: Save Submission field filtering
* Bug Fix: Select conditional logic on load with AJAX cascading
* Bug Fix: Repeatable sections in conversational forms now highlight all rows

= 1.8.97 =
* Added: Meter field type
* Added: New section templates
* Bug Fix: Various CSS fixes
* Bug Fix: Data grid enter key press fix

= 1.8.96 =
* Bug Fix: Elementor pop-ups

= 1.8.95 =
* Added: Support for forms in preview mode in Elementor
* Added: Row select value support for price select fields
* Bug Fix: Pods Yes/No field data grid rows

= 1.8.94 =
* Added: Improvements to functions.php for later PHP versions
* Changed: Behavior of rating field adjusted so that conditional logic does not fire on input

= 1.8.93 =
* Added: Cascading filter column comma separated value setting

= 1.8.92 =
* Added: LiteSpeed cache support
* Added: Notion field ID support in sidebar select fields

= 1.8.91 =
* Added: #seconds_epoch_midnight client-side variable returns seconds elapsed since Unix Epoch up until the closest previous midnight
* Bug Fix: Sidebar repeater select options were not disabling if value contained forward slashes in value
* Bug Fix: Select fields configured to use Select2, multiple and tagging enabled were not appearing in #field variables server side

= 1.8.90 =
* Added: Support for comma separated values in cascading fields
* Added: Hide Child Terms options in Terms data source (Only returns terms with a parent ID of 0)
* Added: Automatic column mapping on 'Get Data' for data sources
* Bug Fix: Data source save on sidebar conditional processing

= 1.8.89 =
* Added: Added checks to ensure Dropzone and Select2 JavaScript libraries are installed before initializing them

= 1.8.88 =
* Added: Improved check for Pods 2.8 Beta get_groups method

= 1.8.87 =
* Added: Additional support for Pods 2.8 Beta
* Bug Fix: Dynamic data source update when form submitted

= 1.8.86 =
* Added: WordPress Filter Hook data source

= 1.8.85 =
* Bug Fix: Improved client side HTML encoding

= 1.8.84 =
* Added: Pods integration support for Post Management (1.3.0) add-on
* Added: Pods integration support for User Management (1.3.0) add-on
* Added: Pods field option data source

= 1.8.83 =
* Added: wsf-steps-checks class for adding checks to styled tabs
* Bug Fix: Fixed invalid feedback reset on field focus

= 1.8.82 =
* Added: Improved performance on DropzoneJS uploads
* Bug Fix: Modal CSS duplication removed

= 1.8.81 =
* Added: 'Exclude From Cart Total' setting on Price, Price Select, Price Checkbox, Price Radio and Price Range fields types. This excludes those fields from the e-commerce calculations so that they can be used for other functionality such as #calc.
* Added: wsf-steps, wsf-vertical form wrapper classes for WS Form framework for tab styling
* Added: wsf-sticky form wrapper, section wrapper and field wrapper classes for WS Form framework
* Added: Tab accessibility improvements

= 1.8.80 =
* Bug Fix: select_option_text, checkbox_label and radio_label compatibility with repeatable sections

= 1.8.79 =
* Added: Placeholder option for Select2 with multiple selected
* Added: License key now obscured after it is entered
* Bug Fix: Select2 rendering

= 1.8.78 =
* Changed: Revised #post* variables for performance

= 1.8.77 =
* Added: Data export request containing registered user data

= 1.8.76 =
* Bug Fix: Field value form scope for #field
* Bug Fix: $submit_object on wsf_submit_field_validate
* Bug Fix: Data export request

= 1.8.75 =
* Added: Ability to hide reCAPTCHA in tabs, sections at field level
* Bug Fix: Tab Google Analytics event firing

= 1.8.74 =
* Bug Fix: Function compatibility issue with WooCommerce extension

= 1.8.73 =
* Added: Multiple choice on Select, Checkbox and Radio IF conditions (OR logic)
* Added: Round robin recipient logged in email action log on each submission

= 1.8.72 =
* Added: Option in email action to include links to file uploads and signatures
* Added: CSV export now includes full paths to file upoads and signatures
* Changed: E-Commerce status column in CSV export changed from 'Status' to 'Order Status' to avoid duplicate column name
* Changed: On submission view, signatures now displayed with preview and download icons to match file upload fields

= 1.8.71 =
* Added: New functions: wsf_form_get_form_object & wsf_form_get_form_label

= 1.8.70 =
* Bug Fix: ACF data source finding choices in grouped or repeater fields

= 1.8.69 =
* Added: WordPress 5.8 compatibility testing
* Added: PHP 8 compatibility testing
* Added: wp_upload_dir known WordPress bug fix

= 1.8.68 =
* Added: Submissions CSV export system now builds in chunks if records exceed 500 to avoid timeouts
* Added: Submissions CSV export system now zips CSV file if it exceeds 1/2 MB in size for convenience

= 1.8.67 =
* Added: Implemented fix for range slider browser bug

= 1.8.66 =
* Added: #calc / #text prioritizes attribute changes before default value changes
* Changed: #calc / #text numeric values changed to 12 decimal point precision

= 1.8.65 =
* Added: ACF fix on LITE

= 1.8.64 =
* Added: Meta Box integration support for Post Management (1.2.0) add-on
* Added; Meta Box integration support for User Management (1.2.0) add-on
* Added: Meta Box field option data source
* Added: Improved wpautop support throughout
* Added: New conditional logic for form submit and save success
* Bug Fix: Repeater column toggle in sidebar on row add
* Bug Fix: Wildcard file accept
* Bug Fix: Bootstrap 5 tabs
* Bug Fix: Checkbox fix in customize
* Bug Fix: Conversation form made PRO

= 1.8.63 =
* Added: Hierarchy support for terms data source (Display as Hierarchy setting)

= 1.8.62 =
* Added: #calc / #text support for min / max field attributes
* Added: Min / max support for price fields in conditional logic

= 1.8.61 =
* Bug Fix: Progress bar assigned to tabs

= 1.8.60 =
* Added: ACF field validation (filter: acf/validate_value) for post and user management actions
* Added: ACF oEmbed field type support
* Changed: Code optimization in public.js
* Bug Fix: Tab click events in conditional logic

= 1.8.59 =
* Bug Fix: Form preview rendering in Gutenberg
* Bug Fix: Field encoding post management populate values

= 1.8.58 =
* Changed: Currency symbols to match WooCommerce

= 1.8.57 =
* Bug Fix: Form submission limit

= 1.8.56 =
* Bug Fix: Message action delay

= 1.8.55 =
* Added: Change to placeholder CSS on inside field label positioning
* Changed: Bricks element updated due to function names changing in Bricks theme core

= 1.8.54 =
* Added: Hovering over tabs, sections and fields in the layout editor with the conditional logic sidebar open now highlights any conditional rows that contain those form elements

= 1.8.53 =
* Bug Fix: Required span on calculated labels
* Bug Fix: Calc firing on repeatable section row count changes

= 1.8.52 =
* Added: Error logging on invalid feedback client side action

= 1.8.51 =
* Added: Bootstrap 5 launch compatibility checks

= 1.8.50 =
* Bug Fix: Conversational style dequeuing

= 1.8.49 =
* Bug Fix: #email_tracking variable in email templates

= 1.8.48 =
* Added: Conversational forms (Beta)
* Changed: PRO licensing
* Bug Fix: Numeric value return on data sources pulling ACF meta data

= 1.8.47 =
* Bug Fix: Initial CSS build error

= 1.8.46 =
* Added: Server-side form validation hook (https://wsform.com/knowledgebase/custom-server-side-form-validation/)
* Added: Performance improvements with CSS engine
* Bug Fix: Form deletion

= 1.8.45 =
* Added: Date field: Disabled days
* Added: Date field: Disabled dates
* Added: Date field: Enabled dates

= 1.8.44 =
* Bug Fix: Visual editor CSS file path issue

= 1.8.43 =
* Bug Fix: x_wp_nonce JS error

= 1.8.42 =
* Added: RTL support for new compiled skin system

= 1.8.41 =
* Bug Fix: Redirect URL parsing now uses text/plain method

= 1.8.40 =
* Bug Fix: Select all fixed on data grids using dynamic data sources

= 1.8.39 =
* Added: Suggested knowledge base articles on support contact form
* Bug Fix: ACF numeric field value population in select, checkbox and radio fields
* Bug Fix: Min / max date validation

= 1.8.38 =
* Added: Improved default invalid feedback text by field type
* Added: Improved appearance of legal field for Foundation framework
* Bug Fix: Server date fix for certain JavaScript engines

= 1.8.37 =
* Added: Name to section library (first name, last name)
* Bug Fix: Applied pre_render filter to submit API call

= 1.8.36 =
* Added: Round robin support for the Send Email action
* Added: Box shadow customization
* Added: Updated version of date time picker JS

= 1.8.35 =
* Added: Support for #text and #calc containing #select_option_text
* Bug Fix: #text on date fields

= 1.8.34 =
* Changed: Improved and consolidated admin UI icons
* Bug Fix: 0 values to ACF fields

= 1.8.33 =
* Bug Fix: Minor bug fix for legacy PHP versions and autocomplete data
* Bug Fix: Validation of dates with period separators fixed for certain JavaScript engines

= 1.8.32 =
* Bug Fix: Dependencies fix

= 1.8.31 =
* Added: Improvement to Elementor pop-up handling
* Added: Calc enabled from HTML fields
* Added: Spacer height setting
* Added: Enqueued script dependency filters (for PayTrace)
* Added: CSS recompiled on upgrade
* Changed: Delete icon continuity throughout admin
* Bug Fix: Bricks preview now uses form preview
* Bug Fix: Select2 CSS

= 1.8.30 =
* Added: Enabled #text on server side to allow static fields to render correctly
* Bug Fix: Price range slider help now correctly formats prices using #ecommerce_price
* Bug Fix: Running actions with conditional logic no longer issues a session ID

= 1.8.29 =
* Added: Hide tabs option (Form --> Settings)
* Bug Fix: Elementor double initializing form events

= 1.8.28 =
* Bug Fix: Shortcode for Oxygen on public contained visual editor attribute

= 1.8.27 =
* Added: Bricks Element (https://bricksbuilder.io/)
* Changed: #pos to #positive, #neg to #negative for future compatibility

= 1.8.26 =
* Added: New variable: #min(value, value ...) - Returns the minimum of the supplied values
* Added: New variable: #max(value, value ...) - Returns the maximum of the supplied values
* Added: New variable: #neg(value) - Returns the 0 if positive, original value if negative
* Added: New variable: #pos(value) - Returns the 0 if negative, original value if positive

= 1.8.25 =
* Added: Improved preview template auto detection
* Added: Improved support for performance optimization plugins

= 1.8.24 =
* Added: Improved Gutenberg block rendering

= 1.8.23 =
* Added: Debug console now removes existing instances if wsf_form_init called

= 1.8.22 =
* Added: Ability to use step of 'any' on number fields
* Bug Fix: Elementor modals

= 1.8.21 =
* Added: WS Form Oxygen element
* Added: Improvements to JavaScript wsf_form_init() function (Reinitializes all forms)
* Added: Improved Beaver Builder, Elementor form initialization
* Added: Improved Gutenberg block functionality
* Added: Note that field deduplication does not work with encryption
* Bug Fix: #calc on multiple select
* Bug Fix: Gutenberg block SVG

= 1.8.20 =
* Added: Client side #section_rows_start(section_id) / #section_rows_end

= 1.8.19 =
* Changed: Removed 'Read more' link from visual editor in admin
* Bug Fix: Visual editor link dialog flashed in Chrome if sidebar was minimized (Known Chrome issue)
* Bug Fix: Military format for time in date field

= 1.8.18 =
* Added: #text(field_id) variable (Allows you to duplicate field values in other fields)
* Added: User status options for tabs (Logged in, logged out, user role, user capability)
* Added: User status options for sections (Logged in, logged out, user role, user capability)
* Added: User logged in, logged out, role and capability conditional logic IF conditions
* Bug Fix: Encryption during WooCommerce checkout

= 1.8.17 =
* Added: Custom Email HTML template
* Added: Email Validation template
* Added: Spam level set to 0 on validated submissions
* Bug Fix: Validation of european date formats using periods

= 1.8.16 =
* Added: #section_rows_start(section_id) / #sections_row_end for email templates
* Added: Public config script optimizations
* Bug Fix: Media library uploads

= 1.8.15 =
* Bug Fix: Fixed hidden field validation for conditional logic validation

= 1.8.14 =
* Added: Improved checks on conditional logic object integrity
* Added: Implemented workaround for select2 not behaving properly with dynamically disabled options

= 1.8.13 =
* Bug Fix: Conditional logic icons if condition deleted

= 1.8.12 =
* Added: Improved signature validation
* Added: Server side #ecommerce_price function
* Added: Signature 'Clear' link text setting
* Added: Google Map 'Reset' link text setting
* Added: Password strength and visibility toggle text settings
* Added: Various Bootstrap and Foundation CSS improvements

= 1.8.11 =
* Added: WordPress 5.7 testing
* Added: Support for tab conditional logic in Bootstrap and Foundation

= 1.8.10 =
* Bug Fix: Conditional logic object ID lookups on form import
* Bug Fix: Next / previous buttons on forms with tab validation
* Bug Fix: Inside label positioning on e-commerce cart total field

= 1.8.9 =
* Added: Conditional logic icons on tabs, sections and fields
* Added: Highlight tabs, sections and fields when editing a condition

= 1.8.8 =
* Bug Fix: Email template parsing

= 1.8.7 =
* Bug Fix: Next / previous tab navigation on conditional logic disable
* Bug Fix: Parse variable processing fix (Server-side)

= 1.8.6 =
* Bug Fix: Media library upload with default file upload field

= 1.8.5 =
* Bug Fix: New form default settings

= 1.8.4 =
* Bug Fix: Required signatures on save

= 1.8.3 =
* Added: Password visibility toggle icon
* Added: Email validation via link in email
* Added: Validate before saving option on save field
* Bug Fix: Action format at on submission save

= 1.8.2 =
* Bug Fix: Tab next/previous buttons if tab hidden with conditional logic

= 1.8.1 =
* Bug Fix: Custom validity removal on hidden fields

= 1.8.0 =
* Added: Section Library
* Added: Section Library (Pre-built and 'My Sections' feature)
* Added: Section and tab import and export
* Added: Section and tab add to 'My Sections'
* Added: Improved tab management in layout editor (settings no longer obscure tab names)
* Added: Performance improvement: Compiled CSS global setting
* Added: Compliance with SCRIPT_DEBUG constant throughout (Minified CSS setting removed from Global Settings)
* Added: Compiled and inline CSS enabled by default for new users
* Added: Field and section search in Toolbox
* Added: Various layout editor UI improvement
* Added: DropzoneJS timeout setting
* Added: Improve statistics gathering methods and error checking
* Added: Latest version of DropzoneJS
* Changed: Removed prefix on form error alerts
* Bug Fix: Foundation 6+ Abide initialization on WooCommerce product pages
* Bug Fix: Data encryption learn more link

= 1.7.158 =
* Bug Fix: File handler pre_get_posts function

= 1.7.157 =
* Added: Priority option on 'Run WordPress hook' action. Can now be run before or after other actions.

= 1.7.156 =
* Added: New modes for add view script

= 1.7.155 =
* Added: Performance improvement: New hooks for add-ons to enqueue scripts if field type exists in form
* Added: Performance improvement: New hook for add-ons to append framework and skin CSS
* Added: Performance improvement: Faster add view script

= 1.7.154 =
* Bug Fix: Firefox scrolling in layout editor

= 1.7.153 =
* Added: None option on button and message types which removes type class

= 1.7.152 =
* Added: Select2 minimum and maximum selection
* Added: Select2 tags option
* Added: Populate search fields
* Added: Fixed header in layout editor
* Bug Fix: Submission ordering

= 1.7.151 =
* Bug Fix: Column count setting

= 1.7.150 =
* Added: Support for comma separated REMOTE_ADDR server variable (Proxied IP)
* Added: Support tabs embedded within third party tabs
* Added: Human Resources templates
* Bug Fix: Submission hidden column user meta option now deleted if form deleted

= 1.7.149 =
* Added: Tab show/hide conditional logic
* Added: Tab hidden setting
* Added: Placeholders and default values for the customize feature

= 1.7.148 =
* Bug Fix: Action list and sub list selected

= 1.7.147 =
* Added: New templates
* Bug Fix: Mapping of file sizes and mime types from ACF field definitions

= 1.7.146 =
* Added: First day of the week setting on jQuery date field

= 1.7.145 =
* Added: File hander class methods for cloud file storage
* Added: Deduplication at a field level within specified period

= 1.7.144 =
* Added: Set HTML conditional logic action for message fields
* Bug Fix: wpautop applied on message content set with conditional logic

= 1.7.143 =
* Bug Fix: Form post lock fix

= 1.7.142 =
* Added: PHP 8 testing
* Added: New checkbox and radio styling classes
* Changed: Various code improvements throughout

= 1.7.141 =
* Bug Fix: Hiding number fields with step

= 1.7.140 =
* Bug Fix: Message JS action

= 1.7.139 =
* Added: Errors settings in Form Settings side bar
* Added: New form complete and error conditional logic
* Changed: File upload size error message to show MB, GB

= 1.7.138 =
* Added: #field_float variable

= 1.7.137 =
* Added: New #submit_url and #submit_link variables for use in emails sent during save for recalling submissions
* Added: Enable save cookie setting

= 1.7.136 =
* Added: New functionality added for Stripe subscriptions

= 1.7.135 =
* Added: #section_row_index and #section_row_number variables
* Added: Conditional logic for DropzoneJS (file count and events)

= 1.7.134 =
* Added: Ability to set quantity min, max and step with conditional logic
* Bug Fix: DropzoneJS capture attribute
* Bug Fix: Removed invalid event on inputmask fields to prevent bug with input mask jquery library
* Bug Fix: Run action immeditely

= 1.7.133 =
* Bug Fix: Duplicate attachments created on ACF record update using DropzoneJS

= 1.7.132 =
* Bug Fix: Removed min value on progress bar field

= 1.7.131 =
* Added: Ability to offset custom date variables by seconds

= 1.7.130 =
* Added: Ability to set minimum / maximum selected on select fields using conditional logic
* Added: Ability to set minimum / maximum checked on checkbox fields using conditional logic
* Added: Ability to set min, max, step on number and range fields using conditional logic

= 1.7.129 =
* Added: ACF file field type mapped as DropzoneJS

= 1.7.128 =
* Changed: clearMaskOnLostFocus input mask setting changed on basic fields (Reverted)

= 1.7.127 =
* Added: Form and submission level variable parsing in JavaScript action

= 1.7.126 =
* Changed: clearMaskOnLostFocus input mask setting changed on basic fields

= 1.7.125 =
* Bug Fix: Localization of #if(...) with #calc in repeaters

= 1.7.124 =
* Bug Fix: Invalid submission hash error handling

= 1.7.123 =
* Bug Fix: Sub type fix

= 1.7.122 =
* Added: Ability to embed static field content with #field variable

= 1.7.121 =
* Bug Fix: Signature file processing

= 1.7.120 =
* Added: Excluding static content in emails templates with conditional logic

= 1.7.119 =
* Added: Map type / zoom retained when form saved

= 1.7.118 =
* Added: Tracking pixel / server side statistics setting
* Added: Sortable DropzoneJS previews
* Bug Fix: Form lock on DropzoneJS upload with populated files

= 1.7.117 =
* Bug Fix: ACF boolean field

= 1.7.116 =
* Changed: Google Map address lookup now only occurs on map click

= 1.7.115 =
* Added: DropzoneJS functionality for file fields with full responsive grid support
* Added: DropzoneJS capture support for front and user facing camera captures
* Added: Minimum and maximum file size settings
* Added: Maximum file upload setting
* Added: WordPress (Public) file upload support
* Added: Submission duration tracking now a setting so it can be disabled
* Added: Added support for ACF gallery field type
* Changed: Changed layout of conventional file field to match other fields to support drag and drop / prefix / suffix
* Bug Fix: Script dequeuing fix for third party plugins that enqueue their scripts everywhere
* Bug Fix: Field mapping excluded password fields

= 1.7.114 =
* Bug Fix: Tab validation

= 1.7.113 =
* Added: Additional ARIA attribute support
* Added: Custom meta to message fields
* Added: Performance improvements
* Added: Ability to use variables in custom attribute values
* Bug Fix: Data grid CSV import empty line
* Bug Fix: Debug number randomization
* Bug Fix: Bypass script

= 1.7.112 =
* Added: New autocomplete field attribute options
* Added: Elementor pop-up compatibility and improved user interface on widget

= 1.7.111 =
* Added: #if() ... #endif variable, e.g. #if(#field(123) == "my value")Show this if field ID 123 equals "my value"#endif (BETA)
* Bug Fix: Select2 with pre-loaded options
* Bug Fix: Email media file attachments

= 1.7.110 =
* Changed: Date presentation functions

= 1.7.109 =
* Added: Cascading checkboxes and radios retain original checked value when rendered
* Added: Term data source meta data columns, including ACF support
* Added: User data source meta data columns, including ACF support

= 1.7.108 =
* Added: Improved select2 full script handling
* Added: SVG template Google Map field
* Changed: Email sidebar fields to be type text instead of email to avoid native errors when entering # variables

= 1.7.107 =
* Added: Google Map field type
* Bug Fix: reCAPTCHA version 3 fix

= 1.7.106 =
* Added: ACF option filtering by post

= 1.7.105 =
* Added: WordPress 5.6 support
* Added: Deregister on scripts that other plugins have not localized to their admin pages

= 1.7.104 =
* Added: Form meta repair routine for import to remap field IDs
* Bug Fix: Form populate section repeatable
* Bug Fix: Conditional logic firing form save on form load in preview mode

= 1.7.103 =
* Added: Final round of IE11 compatibility work

= 1.7.102 =
* Added: Post data source meta data columns, including ACF support
* Added: Select2 / Cascading support of data source searching

= 1.7.101 =
* Bug Fix: Conditional logic disabled field

= 1.7.100 =
* Bug Fix: Conditional logic required field

= 1.7.99 =
* Added: Bootstrap 5 inside label positioning support
* Bug Fix: Left / right label positioning

= 1.7.98 =
* Added: Support for Oxygen visual builder

= 1.7.97 =
* Added: Inside label positioning (Use WordPress Customize -> WS Form -> Advanced to change positioning / scale)

= 1.7.96 =
* Changed: Default values accept variables regardless of mode selected
* Added: Placeholder on step setting

= 1.7.95 =
* Added: Icon tooltips
* Added: Various admin UI improvements
* Added: WCAG compliant interface colors
* Added: Filtered field list for action mapping
* Bug Fix: Debug HTML encoding fix in log

= 1.7.94 =
* Bug Fix: Conditional logic action running

= 1.7.93 =
* Added: Improvements to object, action and conditional logic save / save & close methods
* Bug Fix: Elementor frontend fix

= 1.7.92 =
* Added: Improved form populate null checks

= 1.7.91 =
* Added: Framework improvements for required fields
* Added: Layout editor UI improvements

= 1.7.90 =
* Added: Error handling disabled in visual builder previews
* Bug Fix: Inline CSS rendering in Gutenberg

= 1.7.89 =
* Bug Fix: Upload mime type filtering in repeatable sections

= 1.7.88 =
* Added: Changes made to improve compatibility with WP Rocket

= 1.7.87 =
* Added: Form level restrictions by user role and/or capabilities
* Added: Field level restrictions by user role and/or capabilities
* Added: Data grid row variables 
* Bug Fix: Required file uploads on hidden file fields

= 1.7.86 =
* Bug Fix: Removed form ID check on submit db_update
* Bug Fix: Minor fix on plugin page links

= 1.7.85 =
* Bug Fix: Column mapping on select2 AJAX searching

= 1.7.84 =
* Bug Fix: Admin function hook adjustment to ensure CPTs recognized by post management add-on

= 1.7.83 =
* Added: Further improvements and additions to the template library
* Added: Hidden field value setting and resetting with conditional logic
* Added: Improved API call error response handling with KB support
* Bug Fix: #calc registration in submissions editor sidebar
* Bug Fix: #calc log events when debug not shown
* Bug Fix: Mobile to desktop breakpoint sidebar handling in admin

= 1.7.82 =
* Bug Fix: Gutenberg block

= 1.7.81 =
* Added: Improved template library layout and dynamic SVG generator
* Added: Media attachments for send email action
* Bug Fix: Ratings field on mobile

= 1.7.80 =
* Added: Functionality added for WooCommerce extension version 1.1.41
* Added: Calculated templates
* Added: Read only attribute on rating field type
* Bug Fix: Progress bar events when repeatable section row added
* Bug Fix: Double clicking on field labels while editing

= 1.7.79 =
* Added: wsf_form_init() function to allow adhoc forms to be initialized

= 1.7.78 =
* Added: Form statistics reset

= 1.7.77 =
* Bug Fix: Conditional logic optgroups

= 1.7.76 =
* Added: Prefix and suffix support on fields (Fully Bootstrap and Foundation compatible using input groups)
* Bug Fix: Latest version of CodeMirror caused re-initialize issue

= 1.7.75 =
* Changed: Improved auto else feature on conditional logic so it doesn't apply to event conditions
* Bug Fix: Signature reset conditional logic action firing event
* Bug Fix: Color field reset updating minicolor jQuery component

= 1.7.74 =
* Added: Select2 option on select fields (Supports AJAX)
* Added: Ability to override form element ID in shortcode (element_id)
* Added: Ability to override form element ID in block
* Added: Exclude hidden fields option under screen options in Submissions
* Changed: Clear hidden fields functionality improved

= 1.7.73 =
* Bug Fix: Required conditional logic action

= 1.7.72 =
* Added: Undo, redo and undo history now updates preview
* Changed: Further conditional logic performance improvements

= 1.7.71 =
* Added: Additional tutorial items
* Changed: Conditional logic performance improvements
* Changed: Repeatable section performance improvements
* Changed: Debug console log performance improvements
* Bug Fix: Action and conditional logic read only header

= 1.7.70 =
* Added: Time min/max and invalid input validation on fields using jQuery date/time picker
* Bug Fix: CodeMirror initialization on hidden fields

= 1.7.69 =
* Bug Fix: Return/enter events on input fields
* Bug Fix: Repeatable section hidden fields not cleared

= 1.7.68 =
* Added: Field label save on return/enter
* Bug Fix: Initial action label saving

= 1.7.67 =
* Added: Hidden behavior options on fields: Always Include in Actions, Always Include in Cart Total
* Added: Ability to edit e-commerce fields in submissions (Setting)
* Bug Fix: Show all if no results option on cascading selects (Non-AJAX)

= 1.7.66 =
* Added: File upload image, video and audio previewing

= 1.7.65 =
* Bug Fix: Checkbox and radio grids with cascading values

= 1.7.64 =
* Added: Hidden fields are cleared in emails by default (Can be disabled)
* Added: Hidden fields can be cleared in submissions
* Bug Fix: Validation on hidden fields (HTML 5 compatible)
* Bug Fix: Removed title and meta from fallback preview template
* Bug Fix: Required hidden fields

= 1.7.63 =
* Bug Fix: wsf-rendered trigger

= 1.7.62 =
* Added: Form rendered condition
* Added: Cascading support on multi selects
* Bug Fix: Form navigation firing order

= 1.7.61 =
* Added: AJAX cascading select fields
* Added: Cascading checkboxes
* Added: Support for text, number, range, and rating fields as cascading inputs
* Added: Placeholder text for cascading fields (No results and loading for AJAX requests)
* Added: Improved loader when adding a new form
* Bug Fix: Repeatable section icon coloring
* Bug Fix: Data grid page selectors for high numbers

= 1.7.60 =
* Added: Filter by author in post data source
* Changed: Checkbox and radio styling in WS Form framework
* Bug Fix: Select cascading in Safari

= 1.7.59 =
* Added: Performance improvements
* Added: Improved presentation of dragged fields
* Changed: System table reorganization
* Bug Fix: Min, max validation of fields in repeatable sections
* Bug Fix: Cascading removing events

= 1.7.58 =
* Added: Deduplication of select, radio and checkbox options across repeatable sections

= 1.7.57 =
* Bug Fix: CodeMirror saving in sidebar

= 1.7.56 =
* Added: Improved hide/show conditional logic performance

= 1.7.55 =
* Added: Retained file uploads on form save
* Added: Visual tickmarks on range sliders (Chrome only)
* Added: Custom file upload button label setting

= 1.7.54 =
* Bug Fix: Image selector in data grids

= 1.7.53 =
* Added: Sorting on sidebar repeaters
* Bug Fix: Set custom validity on radio field

= 1.7.52 =
* Bug Fix: Column mapping indexes / ids

= 1.7.51 =
* Added: Ability to to set min / max dates based on + / - days using +1970-01-05 format (e.g. + 4 days)
* Added: Improved detection of date time picker presence (avoids clash with Divi date time picker)

= 1.7.50 =
* Added: Human Presence spam protection
* Changed: Akismet spam protection now found under Form Settings, Spam tab

= 1.7.49 =
* Added: Save form list orderby and order settings by user
* Added: Validation for dates with ordinal indicators
* Changed: Removed DELETE and PUT verbs throughout

= 1.7.48 =
* Added: Minor sidebar CSS fixes
* Bug Fix: Set custom validity only if field will validate

= 1.7.47 =
* Added: Conditional logic date comparison for d/m/Y format
* Changed: Improved Form Settings sidebar layout
* Changed: Improved sidebar CSS throughout

= 1.7.46 =
* Changed: Updated date time picker jQuery component

= 1.7.45 =
* Bug Fix: Field bypassing on hidden file fields
* Bug Fix: Initial rendering of publish button after performance improvements

= 1.7.44 =
* Added: Language support on jQuery date time picker
* Bug Fix: Select all on bulk edit in data grids

= 1.7.43 =
* Added: Min and max date validation on jQuery date picker
* Added: autocomplete options for fields

= 1.7.42 =
* Added: Submissions export filtered by date range
* Added: Improved loading speed of submissions and layout editor
* Changed: Submissions date columns formatted according to field settings

= 1.7.41 =
* Bug Fix: Conditional logic for actions

= 1.7.40 =
* Changed: Select2 REST API authentication for WordPress 5.5+
* Bug Fix: Invalid feedback targeting in conditional logic actions

= 1.7.39 =
* Bug Fix: Submission column ordering

= 1.7.38 =
* Added: Populate field triggering fallback
* Bug Fix: Calc registration on conditional logic actions
* Bug Fix: Conditional logic setting values on price field now currency formatted for input currency mask

= 1.7.37 =
* Bug Fix: Event firing in multiple conditional groups
* Bug Fix: Conditional logic field targeting

= 1.7.36 =
* Bug Fix: Localization of conditional logic in same section

= 1.7.35 =
* Bug Fix: Fallback calc value

= 1.7.34 =
* Added: Support for calc with price column mapping
* Bug Fix: Calc on negative price values

= 1.7.33 =
* Added: Price subtotal and cart total fields now trigger calc fields
* Bug Fix: Minor edit on 'Read Only' setting in admin

= 1.7.32 =
* Added: New reset and clear icons for repeatable section
* Added: Tab, section and field reset and clear conditional logic actions
* Added: Setting to show all options if cascading lookup cannot find a match
* Changed: Improved conditional logic targeting on repeatable sections

= 1.7.31 =
* Added: Various layout editor UI improvements
* Bug Fix: Stacked conditional logic actions
* Bug Fix: Deleted conditional groups caused logic previous to be incorrect

= 1.7.30 =
* Changed: Select, radio and checkbox price mapping can now contain values with currency

= 1.7.29 =
* Added: #section_row_count now works on initial form load
* Bug Fix: Repeatable section radio and checkbox value conditional logic
* Bug Fix: Conditional logic firing when sections are cloned

= 1.7.28 =
* Added: Support for optgroups and fieldsets in cascading select and radio fields
* Bug Fix: Tab selection in Bootstrap 5
* Bug Fix: Data grid column delete removed for single column grids

= 1.7.27 =
* Added: Conditional logic for checked count equals, does not equal, greater than, less than on checkbox fields
* Added: Conditional logic for selected count equals, does not equal, greater than, less than on select fields
* Added: Max checked count limits checking additional checkboxes on checkbox fields
* Added: Max selected count limits selecting additional options on select fields

= 1.7.26 =
* Added: Debug populate feature now excludes fields with calculated values
* Added: Improved debug populate event firing
* Bug Fix: Price select cascading column selection fix

= 1.7.25 =
* Added: Ability to include dividers in emails
* Added: Added wpautop to text editor field output in emails
* Added: Full width value fields in expanded conditional logic view
* Bug Fix: Deactivation fixed if moving between hostnames
* Bug Fix: Added additional new lines to email content to avoid hitting line limit
* Bug Fix: @unserialize was incorrectly causing errors in WP 5.5 so changed this to is_serialized method
* Bug Fix: Removed double <p> tags in email content caused by output of wpautop

= 1.7.24 =
* Added: Dismiss nag fixed

= 1.7.23 =
* Added: Action variable column mapping on price select, checkbox and radio fields

= 1.7.22 =
* Added: LinkedIn conversion tracking
* Changed: Improved settings layout
* Bug Fix: Foundation checkbox and radio field markup

= 1.7.21 =
* Added: Improved support for WAF 403 errors
* Changed: X-HTTP-Method-Override disabled by default

= 1.7.20 =
* Added: Support for minumum and maximum selected/checked in progress bar calculations
* Added: Minimum and maximum checked on price checkbox
* Added: Minimum and maximum selected on price select
* Changed: Improved support for min and max dates for native and jQuery date picker

= 1.7.19 =
* Added: Ability to add click events to navigation buttons
* Bug Fix: Reset and clear applying to fields in repeatable sections

= 1.7.18 =
* Added: Improved rendering of images in submissions table
* Bug Fix: Wrapping submission labels
* Bug Fix: Count submit unread API for submissions

= 1.7.17 =
* Added: Section width support for action update_form method

= 1.7.16 =
* Bug Fix: Unchecked checkboxes now equals 0 in calculations

= 1.7.15 =
* Added: Table CSS added to override issue caused by poor CSS selectors in third party plugins
* Bug Fix: Divi shortcode

= 1.7.14 =
* Bug Fix: IDs on multiple case sensitive checkboxes in conditional logic

= 1.7.13 =
* Added: #pow(base, exponent) variable
* Added: #ecommerce_price(number) variable
* Added: Array to comma delimited setting in custom endpoint action
* Changed: Revised REST endpoint declarations to meet 5.5 requirements

= 1.7.12 =
* Added: Public and mobile toolbar menu features

= 1.7.11 =
* Added: Admin toolbar menu features

= 1.7.10 =
* Added: select_option_text, checkbox_label, radio_label as server side variables
* Bug Fix: Required attributes on variables

= 1.7.9 =
* Added: Bootstrap 5 framework support
* Added: Hooks for TinyMCE configuration
* Added: Improved welcome screen
* Bug Fix: Case sensitivity in conditional logic
* Bug Fix: Gutenberg block fix for visual editor

= 1.7.8 =
* Added: Data grid 'Insert Image' icon
* Added: Select field minimum and maximum selected

= 1.7.7 =
* Added: Section IDs hidden in emails if they are empty
* Bug Fix: Pre-parsing

= 1.7.6 =
* Bug Fix: Calculated field

= 1.7.5 =
* Added: #post_meta, #user_meta now works in all fields
* Added: Various UI improvements

= 1.7.4 =
* Added: Improvements to visual builder modules
* Bug Fix: Data grid tab JS error on click for read only grids

= 1.7.3 =
* Bug Fix: Repeatable section calculations on section add

= 1.7.2 =
* Added: Improved API / Database error handling
* Added: Theme and MySQL variable added to system report
* Changed: Framework detection in settings

= 1.7.1 =
* Bug Fix: mod_security fix

= 1.7.0 =
* Added: Data sources for select, checkbox, radio and fields supporting datalists
* Added: Data source: Preset (Country, State etc)
* Added: Data source: Post (Posts, Pages etc)
* Added: Data source: Term (Category, Tag etc)
* Added: Data source: User
* Added: Data source: ACF (Field choices)
* Added: New value based conditional logic If/Then/Else options
* Changed: Various admin interface styling improvements
* Bug Fix: Changed 'per page' functionality for compatibility with 5.4.2
* Bug Fix: Tab previous and next buttons if no tabs present

= 1.6.24 =
* Bug Fix: Multi-form instance support for repeatable sections
* Bug Fix: TinyMCE button color

= 1.6.23 =
* Added: Additional mod_security fixes to avoid OWASP rule matches

= 1.6.22 =
* Changed: Framework detection

= 1.6.21 =
* Bug Fix: Price format when setting sub totals

= 1.6.20 =
* Added: Action and Conditional Logic row copy
* Bug Fix: Action priority sorting after filter

= 1.6.19 =
* Changed: Form calculation / e-commerce order 

= 1.6.18 =
* Added: Min and max checked on checkboxes 

= 1.6.17 =
* Changed: Field IDs on by default
* Bug Fix: Correct previous logic on first index of conditionals

= 1.6.16 =
* Added: Conditional logic support for multi-selects
* Bug Fix: Trigger on checkbox conditional logic change
* Bug Fix: Debug console log clear

= 1.6.15 =
* Added: Improved SVG previews
* Added: Improved NONCE error notice, now links to helpful KB article
* Bug Fix: Submission page selector if submissions viewed from form selector

= 1.6.14 =
* Added: E-Commerce data to submissions CSV export
* Changed: Default form order
* Changed: CSV export date localized
* Bug Fix: Submission edit and safe

= 1.6.13 =
* Added: Beaver Builder, Divi & Elementor modules to free version
* Bug Fix: nouislider not liking extending String or Date classes

= 1.6.12 =
* Added: Button type: Default
* Added: Email action filters
* Bug Fix: Input mask focussing

= 1.6.11 =
* Bug Fix: wpautop function

= 1.6.10 =
* Added: Progress by tab index
* Bug Fix: Data grid upload

= 1.6.9 =
* Added: Shortcode rendering in text editor, HTML and message fields
* Added: Section vertical alignment
* Changed: Consolidated server PHP objects
* Bug Fix: Submissions form selector

= 1.6.8 =
* Bug Fix: European style thousand separators in prices

= 1.6.7 =
* Added: Additional translated strings
* Added: Auto optimize of breakpoint widths (Removed Optimize buttons)
* Changed: Import / export icons

= 1.6.6 =
* Added: Save & Close button in sidebar
* Changed: Sidebar width

= 1.6.5 =
* Added: Pattern attribute for Email and URL field types
* Changed: Gutenberg block registration from constant to string for WordPress plugin directory

= 1.6.4 =
* Changed: WooCommerce currency setting source

= 1.6.3 =
* Added: Calculation by variable group priority
* Bug Fix: Removed blur event from calculation firing

= 1.6.2 =
* Bug Fix: File download NONCE in submissions

= 1.6.1 =
* Added: Seconds variables

= 1.6.0 =
* Added: Calculated fields - #calc(...)
* Added: Calculated field debugging
* Added: RTL support for admin interface and WS Form framework
* Changed: Gutenberg block always uses WS Form framework
* Bug Fix: Migrate tool
* Bug Fix: Form upload drop release
* Bug Fix: Submission date picker
* Bug Fix: Debug log panel height

= 1.5.37 =
* Changed: Improved detection of Gutenberg editor

= 1.5.36 =
* Added: Revised Gutenberg block
* Added: Live Preview
* Bug Fix: Logout form template
* Bug Fix: Server side currency to number functionality
* Bug Fix: Submit count in debug console
* Bug Fix: WS Form framework offset

= 1.5.35 =
* Added: Variable parser changes ready for calc fields

= 1.5.34 =
* Bug Fix: Customize preview

= 1.5.33 =
* Added: nonce_user_logged_out filter to keep nonces consistent

= 1.5.32 =
* Bug Fix: data-price elements

= 1.5.31 =
* Added: Pathname and query string tracking variables
* Added: Expanded sidebar for submissions
* Added: Ability to expose added post and user to subsequent actions
* Added: Download published JSON form data
* Changed: Style of messages

= 1.5.30 =
* Added: Change name of Alert field to Message

= 1.5.29 =
* Added: Alert field type
* Added: Customize added to WS Form admin menu (Uses form being edited as preview)
* Added: Font size customize option for section and fieldset labels
* Added: Improved fallback form selection for preview 
* Bug Fix: Customize preview

= 1.5.28 =
* Added: wpautop on "Set Content" conditional logic action for text editor fields

= 1.5.27 =
* Added: Variables option for Select, Checkboxes and Radios datagrids

= 1.5.26 =
* Added: Support for actions requiring repeatable submit data
* Added: Support for Populate Using Action requiring repeatable submit data
* Changed: Repeatable options now disable already mapped options
* Bug Fix: Repeatable range slider in submission edit mode
* Bug Fix: Prices with identical decimal and thousand separators

= 1.5.25 =
* Bug Fix: JSON encoding on submit

= 1.5.24 =
* Bug Fix: Thousand separator in prices

= 1.5.23 =
* Bug Fix: Delimiter on variables

= 1.5.22 =
* Added: #checkbox_label variable
* Added: #radio_label variable
* Changed: #select_option_text to support multiple selects

= 1.5.21 =
* Added: File upload progress bar
* Added: Grid feature for checkboxes and radios
* Added: Form submit, save, complete, error conditional logic
* Added: New templates

= 1.5.20 =
* Bug Fix: Decimal separator in prices

= 1.5.19 =
* Bug fix: Bulk options to POST method

= 1.5.18 =
* Bug fix: WSF Plugins loaded action

= 1.5.17 =
* Added: Additional mouse and touch events

= 1.5.16 =
* Added: Media button filter
* Changed: Improved security routines
* Changed: Improved output escaping
* Changed: Script and style enqueueing

= 1.5.15 =
* Added: Checkbox and radio image support

= 1.5.14 =
* Added: REST API testing on Welcome page
* Added: Support for credit card fields
* Changed: Improved settings styling

= 1.5.13 =
* Added: Improved hooks for actions

= 1.5.12 =
* Added: Enqueue core action

= 1.5.11 =
* Changed: Admin JS loaded in footer

= 1.5.10 =
* Added: Review system
* Added: Deactivate feedback system

= 1.5.9 =
* Added: Auto enqueuing of WS Form JS/CSS

= 1.5.8 =
* Added: Cascading field support in repeaters
* Added: Inline CSS and Minified CSS options
* Changed: Default CSS expiry header set to 31536000 seconds

= 1.5.7 =
* Bug Fix: #select_option_text variable selector fix

= 1.5.6 =
* Bug Fix: Parse variable processing section repeatable index JS fix

= 1.5.5 =
* Added: #section_row_count initial fire
* Added: #section_row_count import lookups

= 1.5.4 =
* Added: Section repeatable row count variable
* Added: Section repeatable IF conditional logic

= 1.5.3 =
* Added: Set section repeatable row count
* Changed: Section fieldset HTML

= 1.5.2 =
* Bug Fix: Form e-commerce calculation on locked forms
f
= 1.5.1 =
* Added: Improved form caching for WooCommerce modals
* Added: Responsive section repeatable and rating icons
* Added: Font weight in appearance settings

= 1.5.0 =
* Added: Repeatable sections
* Added: Conditional logic for repeatable sections
* Added: E-Commerce calculations for repeatable sections
* Added: New Add / Remove fields for repeatable sections
* Added: New Move Up / Down fields for repeatable sections
* Added: New icons field for repeatable sections
* Added: Repeatable sections rendering in submissions and emails
* Added: Draggable repeatable sections
* Added: Repeatable editing in submissions
* Added: New field event: On change or input
* Added: Rating horizontal alignment / spacing
* Added: Elementor 
* Changed: Improved script enqueuing
* Changed: Improved default color palette with improved contrast ratio
* Bug fix: Empty file fields on save
* Bug fix: Options caching on settings save
* Bug fix: Event firing conditional logic improvements

= 1.4.101 =
* Bug Fix: PHP 5.6 legacy code fix in setup_from_post

= 1.4.100 =
* Bug Fix: Repeatable sections pre-release issue

= 1.4.99 =
* Bug Fix: Radio fields on tab validation

= 1.4.98 =
* Changed: Performance improvements
* Bug Fix: CodeMirror field initialization in sidebar on hidden tabs

= 1.4.97 =
* Bug Fix: File real-time validation

= 1.4.96 =
* Added: Conditional logic firing on price total changes

= 1.4.95 =
* Changed: Improved ecommerce calculation locking for fixed price forms

= 1.4.94 =
* Changed: Latest version of inputmask

= 1.4.93 =
* Bug Fix: Input mask on currency fields

= 1.4.92 =
* Changed: Improved script enqueuing dependencies and versioning. Head / footer script enqueuing

= 1.4.91 =
* Bug Fix: Zero e-commerce amounts

= 1.4.90 =
* Bug Fix: Repeater down arrow on condensed columns
* Bug Fix: Action data serialization on submit

= 1.4.89 =
* Bug Fix: Save notifications on rapid sidebar switching
* Bug Fix: Required fields on hidden sections

= 1.4.88 =
* Changed: Improved underlying post data for previews

= 1.4.87 =
* Added: Tab validation
* Added: Tab, section, field validation in conditional logic
* Added: Workaround if other plugins have post loop bug in preview

= 1.4.86 =
* Bug Fix: Tab sorting

= 1.4.85 =
* Changed: Improved sidebar save

= 1.4.84 =
* Changed: Improved form statistics performance
* Bug Fix: Safari file input check bug

= 1.4.83 =
* Changed: Updated jquery.inputmask to newer version

= 1.4.82 =
* Added: Select2 sidebar field type for WooCommerce add-on
* Bug Fix: User ID logging on submissions

= 1.4.81 =
* Added: Range slider track filling

= 1.4.80 =
* Bug Fix: Cart total format fix

= 1.4.79 =
* Changed: Thousand separator inherited from e-commerce settings for price rendering

= 1.4.78 =
* Changed: Improved submit button targeting for disable / cursor on submit

= 1.4.77 =
* Bug Fix: Get currency function for different currency alignment

= 1.4.76 =
* Bug Fix: Action get fixed when user logged out

= 1.4.75 =
* Added: Additional WCAG compliance items
* Added: Improved post management

= 1.4.74 =
* Changed: Improved form unlocking

= 1.4.73 =
* Changed: Divi changes for latest version
* Changed: CSS changes for latest WP version
* Bug Fix: Post setup on actions

= 1.4.72 =
* Added: Option population custom end points
* Bug Fix: Welcome AJAX test step buttons
* Bug Fix: Sidebar field option filtering

= 1.4.71 =
* Added: CSS expire headers option

= 1.4.70 =
* Changed: Search action form ID identification

= 1.4.69 =
* Bug Fix: Elementor front-end fix

= 1.4.68 =
* Bug Fix: Published form array fix

= 1.4.67 =
* Bug Fix: Rating field events
* Bug Fix: Submission printing
* Bug Fix: Bypass mod_security # sensitivity on Bluehost (Ticket: 18835473)

= 1.4.66 =
* Added: Show form if logged out
* Bug Fix: Action firing with conditional logic

= 1.4.65 =
* Bug Fix: Action logging

= 1.4.64 =
* Added: Elementor widget
* Added: Dark mode for debug console
* Added: random_number and random_string functions

= 1.4.63 =
* Bug Fix: Multi-instance required field bypassing
* Bug Fix: Message clearing on form reload

= 1.4.62 =
* Added: Input mask on date field type
* Added: Year start and finish on date field type

= 1.4.61 =
* Bug Fix: Debug Console visibility

= 1.4.60 =
* Added: Legal field type
* Added: Termageddon integration
* Bug Fix: Meta data deletion

= 1.4.59 =
* Added: Beaver Builder module
* Changed: Welcome screen improvements
* Changed: Search with no keyword still runs search
* Changed: Various CSS upgrades
* Bug Fix: Framework detection performance improvements
* Bug Fix: Scrolling on debug tab if third party scroll component installed

= 1.4.58 =
* Changed: Updated ARIA attributes
* Changed: Shortcode copy improvement
* Bug Fix: Time picker format

= 1.4.57 =
* Added: pattern attribute on date fields
* Added: Shortcode copy feature
* Changed: Updated ARIA attributes
* Bug Fix: pattern removed from textarea
* Bug Fix: Tracking variable parsing
* Bug Fix: Form table tr

= 1.4.56 =
* Added: Date field level date and time formats
* Added: Form unlock controls

= 1.4.55 =
* Added: WordPress 5.3 CSS improvements
* Added: Date comparison conditional logic

= 1.4.54 =
* Added: WordPress 5.3 compatibility

= 1.4.53 =
* Added: Additional functions for reading / writing submit data
* Bug Fix: Save button locking and functionality

= 1.4.52 =
* Changed: Action firing priority of redirect
* Bug Fix: Field and section rendering in admin
* Bug Fix: Data grid checkbox IDs

= 1.4.51 =
* Added: CSS modifications for static

= 1.4.50 =
* Added: Stats disabling

= 1.4.49 =
* Added: Context sensitive help icons
* Bug Fix: Conditional logic row actions

= 1.4.48 =
* Added: wsf-form-canvas class

= 1.4.47 =
* Changed: wsf-form class for non standard form implementation styling
* Bug Fix: Message clearing on multiple form instances

= 1.4.46 =
* Bug Fix: Action firing on forms with custom actions
* Bug Fix: Sidebar AJAX population with blank options

= 1.4.45 =
* Changed: Email action priority
* Changed: Search query var and pre_get_posts priority

= 1.4.44 =
* Added: Search field type and template
* Added: 5.2.4 testing

= 1.4.43 =
* Added: Search action
* Added: Functionality for WooCommerce add-on
* Changed: Removed flex option
* Changed: Email action from and to name encoding
* Changed: Renamed Progress Bar to Progress

= 1.4.42 =
* Bug Fix: CSS update

= 1.4.41 =
* Added: Additional field styling options to fields
* Added: Additional icons for KB articles
* Changed: Removed promo from plain text email template
* Bug Fix: Action repeater field ID repair on JSON import
* Bug Fix: Cascading select and radio fields in iOS

= 1.4.40 =
* Added: Cascading select and radio fields
* Bug Fix: Data grid label fix

= 1.4.39 =
* Changed: Support system integrated with Zendesk
* Bug Fix: Rich editing and syntax highlight toggling in public.js

= 1.4.38 =
* Added: Action meta key variable default values

= 1.4.37 =
* Bug Fix: E-commerce cart total logging on fixed price payment buttons

= 1.4.36 =
* Bug Fix: Color variable fix

= 1.4.35 =
* Added: Color checkboxes and radios
* Added: How to templates

= 1.4.34 =
* Bug Fix: Input validation method (Overcomes jQuery mobile issue)

= 1.4.33 =
* Changed: Improved e-commerce meta data rendering on submits

= 1.4.32 =
* Added: New user management support

= 1.4.31 =
* Added: Additional templates
* Changed: Improved clarity of templates
* Changed: Default required string
* Bug Fix: Visual Editor keyup event

= 1.4.30 =
* Added: Additional templates
* Changed: Dynamic template SVGs

= 1.4.29 =
* Added: Date picker styles
* Changed: Improved template management

= 1.4.28 =
* Changed: Improved form stat additions
* Changed: Form add hooks

= 1.4.27 =
* Bug Fix: Hidden visual text editor

= 1.4.26 =
* Changed: Form reset / clear conditional re-run
* Bug Fix: Import form ID lookups

= 1.4.25 =
* Bug Fix: Price parsing fix

= 1.4.24 =
* Added: Exclude from email setting on fields
* Changed: Improved presentation of price field values
* Changed: Improved presentation of multi-select fields in submit sidebar and emails

= 1.4.23 =
* Added: Routines for WooCommerce
* Added: Action log now uses action label
* Added: Layout editor tutorial
* Bug Fix: Drag and drop datagrid
* Bug Fix: Drag and drop form upload

= 1.4.22 =
* Added: Field vertical alignment
* Added: Button type styling classes

= 1.4.21 =
* Bug Fix: Minor bug fix on settings page

= 1.4.20 =
* Added: Routines for WooCommerce
* Added: AJAX form firing toggle
* Added: MutationObserver on forms to remove them from debug console
* Changed: Improved descriptions for e-commerce variables
* Changed: E-Commerce settings now pulled from WooCommerce if installed
* Changed: Improved clarity on labels in layout editor
* Changed: Reset button type now submit
* Changed: Submit buttons set to disabled on lock
* Bug Fix: Action firing with conditional logic

= 1.4.19 =
* Added: Cart price span variables
* Changed: Better handling of cart price fields
* Changed: Better event triggering
* Changed: Improved cart calculation
* Bug Fix: Password meter reset on password delete
* Bug Fix: Variables pop-up

= 1.4.18 =
* Added: Routines for WooCommerce
* Bug Fix: HTML escaping in select, radio and checkbox values
* Bug Fix: Screen option saving on submissions

= 1.4.17 =
* Bug Fix: DB fix

= 1.4.16 =
* Added: Submission count in admin menu
* Bug Fix: Action firing by conditional logic
* Bug Fix: Divi styling

= 1.4.15 =
* Added: New functionality to support Salesforce add-on
* Bug Fix: Admin icon fix
* Bug Fix: Export warning

= 1.4.14 =
* Bug Fix: WS Form icon rendering
* Bug Fix: Additional third party plugin CSS overrides

= 1.4.13 =
* Bug Fix: reCAPTCHA size attribute (normal / compact)

= 1.4.12 =
* Bug Fix: Max upload size JS error fix

= 1.4.11 =
* Bug Fix: Plain text email fix

= 1.4.10 =
* Bug Fix: Price floating point fix

= 1.4.9 =
* Bug Fix: Improved reCAPTCHA / signature conditional logic on hidden sections

= 1.4.8 =
* Added: Additional blog date / time variables
* Bug Fix: Select conditional logic actions

= 1.4.7 =
* Bug Fix: Correct formatting on visual editor email templates

= 1.4.6 =
* Bug Fix: Improvements to file upload routines

= 1.4.5 =
* Added: Support for featured images on posts

= 1.4.4 =
* Bug Fix: Signature real time validation event triggering

= 1.4.3 =
* Added: Disabled submit on enter key by default. Can be re-enabled in form settings

= 1.4.2 =
* Added: Populate functionality for improved date functionality
* Bug Fix: Import of uninstalled field types

= 1.4.1 =
* Added: New e-commerce variables
* Changed: Improved date / color field native support
* Changed: Date jQuery component destroyed if date field made readonly
* Changed: Additional fixed classes added for styling
* Changed: E-Commerce calculation fired on conditional login processing
* Bug Fix: Text editor not saving unless keypress occurs
* Bug Fix: Signature required status
* Bug Fix: Minor conditional logic styling fix

= 1.4.0 =
* Added: Divi visual builder component
* Bug Fix: PRO badges
* Bug Fix: Lower bulk action dropdowns

= 1.3.35 =
* Added: Support for list subs (Google Sheets)
* Added: Variables in message action
* Changed: Improved CSV export
* Bug Fix: Checkbox event firing

= 1.3.34 =
* Added: CSS for toggle checkboxes
* Bug Fix: Conditional actions
* Bug Fix: Blank emails ignored in email action

= 1.3.33 =
* Changed: Improved #email_submission rendering

= 1.3.32 =
* Changed: Improved performance for visibility conditional logic

= 1.3.31 =
* Bug Fix: Field required bypassing

= 1.3.30 =
* Bug Fix: Fixed validation on hidden select, radio and checkboxes
* Bug Fix: Foundation hidden field fix

= 1.3.29 =
* Bug Fix: wpautop fix on text editor field

= 1.3.28 =
* Added: #select_option_text variable
* Bug Fix: wp_footer enqueue priority

= 1.3.27 =
* Bug Fix: Preview with form limits

= 1.3.26 =
* Bug Fix: DB key fixes
* Bug Fix: Encryption constant bug fix for older PHP versions

= 1.3.25 =
* Bug Fix: Improved handling of user_can_richedit flag

= 1.3.24 =
* Changed: Improved API error handling
* Bug Fix: Submission delete with deleted file attachment

= 1.3.23 =
* Added: Additional RTL classes
* Bug Fix: EDD update class fixes

= 1.3.22 =
* Added: RTL classes

= 1.3.21 =
* Added: Field types can now be clicked to add them
* Bug Fix: Export of select, radio and checkbox array data

= 1.3.20 =
* Bug Fix: Add-on templates (PRO)
* Bug Fix: Preview

= 1.3.19 =
* Added: Instant and smooth scrolling for messages and next/previous tab buttons. Offset for scroll.

= 1.3.18 =
* Bug fix: Form validation fixes

= 1.3.17 =
* Bug fix: Signature redraw in Bootstrap (PRO)

= 1.3.16 =
* Bug fix: REST API path fix

= 1.3.15 =
* Changed: Improved next/previous functionality
* Bug fix: Validation on hidden fields with min / max values

= 1.3.14 =
* Bug Fix: Windows incorrectly reports MIME types for CSV files. Changed file format detection.

= 1.3.13 =
* Added: #user_meta variables

= 1.3.12 =
* Bug Fix: Multiple calls to shortcode in wp_head caused rendering errors in preview mode

= 1.3.11 =
* Added: Locate feature now checks posts as well as pages and widgets
* Changed: Preview template reset to automatic on theme change
* Bug Fix: Submit button width on free version

= 1.3.10 =
* Bug Fix: Date time picker loading improvement

= 1.3.9 =
* Changed: Optimized form config on public side
* Changed: Improved nonce handling
* Changed: Improve password security script handling

= 1.3.8 =
* Bug Fix: Icon

= 1.3.7 =
* WordPress 5.1 testing
* Changed: Improved API error handling

= 1.3.6 =
* Added: HKDF-SHA256 AES-256-CTR encryption of submission data (PRO)

= 1.3.5 =
* Bug Fix: Honeypot field Abide validation in Foundation
* Bug Fix: Removed dependency on mime_content_type()
* Bug Fix: Hidden required field fixes

= 1.3.4 =
* Bug Fix: # encoding in URL data
* Bug Fix: Password field language data
* Bug Fix: Preview wp_query posts_per_page attribute override

= 1.3.3 =
* Added: Dashboard for submission statistics widget
* Changed: Added IDs to submissions list
* Bug Fix: Screen options
* Bug Fix: Form & submission status links 

= 1.3.2 =
* Added: Locate where forms are embedded in pages and widgets

= 1.3.1 =

* Added: WPForms migration tool (PRO)
* Added: Deduplication option on fields
* Added: Various WS Form framework styling improvements
* Bug Fix: Improvements to migration import engine

= 1.3.0 =

* Added: Gravity Forms and Visual Form Builder Pro migration tool (PRO)
* Added: Rating field type (PRO)
* Added: Form stats capturing and display on form list (PRO)
* Added: Submission starred states
* Added: Submission viewed states
* Added: Submission count limiting (PRO)
* Added: Form scheduling (PRO)
* Added: Form only show if user logged in (PRO)
* Added: Visual editor and HTML editor options for textarea field types (PRO)
* Added: Ability to hide fields
* Added: Spam filter level selector
* Added: Ability to set value of text editor fields using conditional logic (PRO)
* Added: Select All on checkbox fields
* Changed: Improved visual editor and HTML editor rendering
* Changed: Improved database indexing
* Changed: IDs and/or submission counts added for form lists
* Bug Fix: Default color value
* Bug Fix: Sentence population
* Bug Fix: Improved form reload handling
* Bug Fix: Submit duration

= 1.2.20 =

* Bug fix: Support for websites using MooTools

= 1.2.19 =

* Added: Custom Endpoint action (PRO)

= 1.2.18 =

* Added: New functions and filters for manipulating forms prior to rendering (PRO)
* Added: Form, tab and section IDs added to sidebars
* Added: Custom form action

= 1.2.17 =

* Bug fix: Full width class fix on buttons

= 1.2.16 =

* Added: Ability to remove full width class on buttons
* Bug fix: Removed currency symbols from default price select, radio and checkbox fields (PRO)

= 1.2.15 =

* Added: Form import / export on form list page
* Added: E-Commerce price range field type (PRO)
* Added: E-Commerce form examples (PRO)
* Changed: Improved email field validation for progress bars (PRO)
* Bug fix: Form trash

= 1.2.14 =

* Added: Custom field attributes
* Changed: Password field added to core (PRO)
* Bug fix: Improved field dependency adjustments on delete
* Bug fix: Margin on text editor fields

= 1.2.13 =

* Added: Various improvements to mobile / wordpress.com styling and layout
* Added: New loader style

= 1.2.12 =

* Added: Improved admin styling for WordPress websites hosted on wordpress.com
* Added: New functionality for supporting Authorize.Net Accept payments (PRO)
* Added: Improved population of phone numbers (PRO) and IP addresses
* Bug fix: Various bug fixes for improved stability

= 1.2.11 =

* Added: New JavaScript trigger events

= 1.2.10 =

* Bug fix: Save form state (PRO)

= 1.2.9 =

* Changed: Improved detection of page templates for previewing

= 1.2.8 =

* Added: Option to show action misconfiguration errors client side
* Bug fix: Multi-site debug console (PRO)
* Bug fix: Removed dependency on pluggable.php

= 1.2.7 =

* Changed: Improved debugger fonts
* Bug fix: Chrome draggable bug
* Bug fix: DataGrid rows per page bug

= 1.2.6 =

* Changed: Improved framework detection script
* Added: E-Commerce price field alignment (PRO)
* Bug fix: Divider and spacer field types for Foundation

= 1.2.5 =

* Added: Image setting for sidebar
* Changed: Action updated ready for new payment add-ons (PRO)

= 1.2.4 =

* Changed: Improved text alignment for e-commerce fields (PRO)

= 1.2.3 =

* Changed: Improved debug population for checkbox and radio fields (PRO)
* Bug fix: Price text justified on cart detail fields
* Bug fix: Bootstrap 3 radio and checkbox fixes

= 1.2.2 =

* Added: Ability to run any action via conditional logic (PRO)
* Changed: Improved variables help
* Bug fix: One time use fields no longer copied
* Bug fix: Server side action handler

= 1.2.1 =
* Bug fix: Form validation

= 1.2.0 =
* Added: New form level conditional logic, including 'On validated'
* Added: New progress bar conditional logic
* Added: Improved notifications for required field settings
* Added: E-Commerce functionality (PRO)
* Added: Support for e-commerce payment methods (PRO)
* Changed: Improved conditional logic event firing
* Changed: Improved upgrade and add-on functionality
* Changed: Additions to CSS to fix problems caused by third CSS implementations
* Bug fix: Submission tab labels
* Bug fix: jQuery UI CSS overrides
* Bug fix: Improved form preview functionality and permalink detection for API calls
* Bug fix: Data grid labels for groups rendering
* Bug fix: Submit meta data overwrite
* Bug fix: Bootstrap wrappers
* Bug fix: Foundation 6.4+ tabs
* Bug fix: Tab and section copying now excludes single use fields (e.g. reCAPTCHA)

= 1.1.11 =
* Added: Disabled icon on sections
* Changed: Additions to CSS to fix problems caused by third CSS implementations
* Bug fix: DB inserts for form and field
* Bug fix: Sidebar conditions

= 1.1.10 =
* Changed: Improved admin CSS to fix problems caused by third CSS implementations

= 1.1.9 =
* Changed: Submit save now retains actions
* Bug fix: Progress bar and data grid rows
* Bug fix: Conditional logic auto page add

= 1.1.8 =
* Bug Fix: Color picker CDN path
* Bug Fix: Signature progress bar
* Bug Fix: File download API paths for permalinks not using postname

= 1.1.7 =
* Added: Gutenberg support for forthcoming Wordpress 5
* Added: Keyboard shortcuts in submissions editor
* Bug fix: Word and character count validation

= 1.1.6 =
* Added: Support for new PDF add on
* Changed: Improved email template

= 1.1.5 =
* Bug Fix: Akismet header return

= 1.1.4 =
* Added: Option to include file and signature fields in emails (PRO)
* Added: Image optimization and MIME type selector in file field type (PRO)
* Bug Fix: Blank signature detection (PRO)
* Bug Fix: Publish button fix on JSON form upload

= 1.1.3 =
* Added: Signature cropping, JPG background colors and inline embedding in emails (PRO)
* Added: Option to exclude empty fields in email submissions
* Changed: Improved built in email template
* Bug Fix: Improved variable parsing

= 1.1.2 =
* Added: Client side date variables
* Added: Automatic handling of hidden required fields

= 1.1.1 =
* Changed: Optimized client side JavaScript
* Bug Fix: reCAPTCHA field (PRO)
* Bug Fix: Signature components loaded via CDN and hidden with conditional logic (PRO)

= 1.1.0 =
* Added: Email action to basic edition
* Added: Data Export Request action to basic edition
* Added: Data Erasure Request action to basic edition
* Changed: Activation script improvements

= 1.0.9 =
* Added: Link to support tickets in support sidebar
* Bug Fix: Tab deletion

= 1.0.8 =
* Added: Support for Campaign Monitor plugin (PRO)
* Added: Visible field IDs in advanced mode
* Bug Fix: Field API

= 1.0.7 =
* Added: Support for Zapier plugin (PRO)
* Bug Fix: Improved API security

= 1.0.6 =
* Added: Input masks
* Added: CDN / Local options for external jquery libraries (PRO)
* Bug Fix: Select conditional was not firing on 'Is Selected' (PRO)

= 1.0.5 =
* Added: More variables that reference customize appearance values
* Added: Improved Welcome screen error detection to ensure WordPress is installed correctly
* Added: Run hook function now supports firing a message or redirect on complete (PRO)
* Added: Support for new Slack add-on (PRO)
* Bug Fix: Error handling bug fix on public script

= 1.0.4 =
* Added: Conversion Tracking action for Google and Facebook (PRO)
* Added: Run JavaScript action allows JS to be fired on form save and submit (PRO)
* Bug Fix: Section legend custom masks

= 1.0.3 =
* Added: New preview options in settings
* Bug Fix: Improved Gutenberg support
* Bug Fix: Support for sub-domain websites

= 1.0.2 =
* Added: Progress bar field type and variable functionality (PRO)
* Added: reCAPTCHA Version 3 support integrated with WS Form spam system (PRO)
* Added: Additional user variables
* Changed: Performance improvements
* Changed: Improved mobile version of form builder
* Bug Fix: Message action clear function
* Bug Fix: WordPress editor integration

= 1.0.1 =
* Added: Gutenberg support
* Added: Integrated knowledge base search
* Changed: Performance improvements

= 1.0.0 =
* Initial release.
